SystemOrganization addCategory: #DCD6!

Profiler subclass: #DCD6TestCoverage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DCD6'!

!DCD6TestCoverage class methodsFor: 'as yet unclassified' stamp: 'aebif 4/17/2012 18:56'!
spyClassForPackage
	^ DCD6TestCoveragePackage.! !

!DCD6TestCoverage methodsFor: 'as yet unclassified' stamp: 'aebif 12/6/2011 09:32'!
visualizeOn: view
	view nodes: self allClasses forEach: [ :each |
		view shape rectangle
			height: #numberOfLinesOfCode;
			width: [ :m | (m numberOfDifferentReceivers + 1) log * 10 ]; 
			linearFillColor: [ :m | ((m numberOfExecutions + 1) log * 10) asInteger ] within: self allMethods;
			borderColor: [:m | m isCovered ifTrue: [ Color black ] ifFalse: [ Color red ] ].
		view interaction action: #inspect. 
		view nodes: (each methods sortedAs: #numberOfLinesOfCode). 
		view gridLayout gapSize: 2.].
	view edgesFrom: #superclass. view treeLayout! !

WAFileLibrary subclass: #DCD6FileLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DCD6'!

!DCD6FileLibrary methodsFor: 'as yet unclassified' stamp: 'fredaebi 3/27/2012 08:52'!
layoutCss
^ '
body
{
	font-family: "Helvetica Neue", Helvetica, Arial, sans-serif;
	font-size: 12pt;
}

h1, h2, h3, h4, h5
{
	font-weight: normal;
	padding: 0px;
	margin: 0px;
	margin-bottom: 10px;
}

p
{
	pardding: 0px;
	margin: 0px;
	margin-bottom: 5px;
}

#header
{
	margin: 50px;
	height: 50px;
	border-bottom: solid 1px #F0F0F0;
}

#header ul
{
    padding: 0px;
    margin: 0px;
    list-style-type: none;
}

#header li
{
    margin-right: 10px;
    float: right;
}

#header ul li a
{
    display: block;
    float: left;   
    width: 100px;
    color: #36A1D6;
    text-decoration: none;
    text-align: center;
    padding: 5px;
    background: #F7F7F7;
    -moz-border-radius: 7px;
    -webkit-border-radius: 7px;
    border-radius: 7px;
}

#header ul li a:hover
{
    background-color: #F0F0F0;
}

#header div
{
	float: left;
}

#content
{
	margin: 50px;
}

#content ul
{
	padding: 0px;
	margin: 0px;
	list-style-type: none;
}

#content a
{
	color: #36A1D6;
    	text-decoration: none;
}

#content a:hover
{
	text-decoration: underline;
}

#versions, #suspects
{
	border-collapse: collapse;
	margin:0px;
	padding:0px;
}

#versions th, #suspects th
{
	text-align: left;
	background: #F0F0F0;
}

#suspects th.big
{
	width: 30%;
}

#suspects th.small
{
	width: 10%;
}

#versions td, #suspects td
{
	width: 150px;
	border-bottom: solid 1px #F0F0F0;
}

#versions th.center, #versions td.center, #suspects th.center, #suspects td.center,
{
	text-align: center;
}

#progress {
	visibility: hidden;
}

.ui-dialog .ui-dialog-titlebar-close span {
	display: none;
}

'.! !

!DCD6FileLibrary methodsFor: 'uploaded' stamp: 'fredaebi 3/26/2012 12:53'!
spinnerGif
	^ #(71 73 70 56 57 97 220 0 33 0 227 0 0 188 190 188 220 222 220 236 238 236 212 214 212 244 246 244 204 202 204 228 230 228 252 250 252 255 255 255 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 33 255 11 78 69 84 83 67 65 80 69 50 46 48 3 1 0 0 0 33 249 4 9 6 0 8 0 44 0 0 0 0 220 0 33 0 0 4 254 16 201 73 171 189 56 235 205 187 255 96 40 142 100 105 158 104 170 174 108 235 190 112 44 207 116 109 223 120 174 239 124 239 255 192 160 112 72 44 26 143 200 164 114 201 108 58 99 7 131 116 74 157 10 58 130 170 86 122 224 68 183 213 43 39 11 166 118 55 223 178 84 188 33 171 13 103 77 90 205 214 184 213 241 12 1 192 239 251 251 1 29 3 127 132 124 121 24 123 133 127 3 29 1 138 127 135 23 137 143 124 129 28 131 148 134 28 147 148 150 27 152 153 145 22 7 0 1 6 100 168 82 5 140 151 5 167 175 175 89 142 162 21 123 166 169 176 171 130 174 169 89 178 0 180 20 182 176 184 186 173 190 177 175 179 155 165 196 107 170 172 159 188 201 100 203 27 195 206 175 198 210 86 97 214 26 182 200 206 219 26 3 174 217 167 223 122 205 217 89 228 25 230 221 84 2 234 136 236 184 238 209 229 231 119 202 192 94 165 250 81 121 135 33 94 191 106 255 174 177 3 67 240 66 188 50 245 36 45 220 210 208 130 193 48 82 34 90 192 198 80 31 188 115 254 243 166 104 172 181 80 96 197 10 15 159 81 25 41 108 98 152 147 20 46 110 97 57 97 24 62 104 187 212 56 34 192 236 86 199 156 2 51 38 148 227 50 21 204 9 50 181 208 148 16 78 165 155 163 18 82 102 219 217 83 13 84 4 73 239 80 85 104 170 27 178 171 82 221 252 10 86 51 160 188 41 96 65 122 53 176 20 1 199 108 105 97 57 219 10 238 30 53 3 113 229 249 162 187 174 171 92 180 30 11 78 11 201 22 0 79 52 118 85 226 13 236 112 176 82 195 85 255 2 206 9 17 50 87 171 140 45 58 174 194 215 158 207 179 87 3 168 237 215 89 162 223 131 121 255 254 58 92 215 47 198 184 184 68 90 110 45 121 114 43 194 178 89 247 85 108 5 54 152 210 163 92 86 73 123 48 119 207 155 56 111 107 65 168 219 179 94 219 210 4 50 175 90 124 49 101 116 192 73 118 13 154 90 114 246 150 159 181 164 22 39 180 185 233 218 167 198 255 253 94 214 181 248 204 40 213 62 54 31 220 253 29 245 156 103 239 46 67 188 50 125 237 152 93 137 55 147 126 206 225 102 29 7 162 241 230 207 127 45 245 81 0 33 15 194 23 147 131 133 60 200 96 89 0 60 72 97 134 124 72 56 129 35 27 242 161 33 129 18 113 232 199 136 0 120 24 85 136 38 102 120 33 83 34 198 72 136 138 88 157 40 99 31 47 34 16 69 80 243 116 64 192 27 92 120 193 99 143 99 0 9 135 23 70 214 161 135 145 100 73 48 71 25 74 34 194 228 19 84 86 105 229 149 88 102 169 229 150 92 118 233 229 151 96 134 41 230 152 100 150 105 230 153 104 166 169 230 154 108 158 16 1 0 33 249 4 9 6 0 18 0 44 0 0 0 0 220 0 33 0 132 172 170 172 212 214 212 196 194 196 236 238 236 180 182 180 228 226 228 204 206 204 220 222 220 204 202 204 244 246 244 188 190 188 180 178 180 220 218 220 196 198 196 188 186 188 228 230 228 212 210 212 252 250 252 255 255 255 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 5 254 160 36 142 100 105 158 104 170 174 108 235 190 112 44 207 116 109 223 120 174 239 124 239 255 192 160 112 72 44 26 143 200 36 13 178 88 16 156 208 232 115 10 165 38 148 216 172 150 134 88 8 26 223 48 184 49 22 139 21 128 235 118 205 110 143 26 132 131 252 80 144 215 233 246 60 30 146 118 251 255 73 8 4 117 119 133 122 134 114 124 106 128 140 141 62 130 132 116 12 134 148 146 5 6 125 142 154 155 54 130 115 7 16 6 161 163 162 165 16 16 118 138 39 3 15 173 174 175 174 17 44 17 176 181 173 3 45 172 182 176 178 43 180 187 175 184 44 186 192 173 189 42 191 197 15 194 43 196 197 199 36 144 117 12 14 4 14 213 215 214 216 14 13 119 170 38 1 2 10 2 226 229 227 229 139 41 9 230 228 231 238 1 45 12 228 243 244 243 10 233 40 235 238 237 252 2 240 44 242 234 9 188 199 66 95 191 113 238 24 196 235 39 80 28 62 17 158 36 17 16 5 33 192 41 139 167 32 40 232 70 7 211 67 9 1 16 20 147 247 177 196 58 6 197 254 16 252 91 193 160 91 171 2 15 96 198 124 64 178 160 0 148 192 84 182 8 41 19 102 79 154 2 74 146 56 153 114 165 10 158 174 126 22 168 105 2 129 3 60 212 84 86 156 90 49 64 0 5 8 228 48 248 86 34 100 177 2 14 132 142 72 160 224 64 209 157 34 129 49 32 232 75 1 206 93 58 89 120 85 203 22 153 219 179 114 211 238 58 80 55 90 28 173 19 167 90 180 122 17 235 158 76 93 245 178 26 80 64 23 83 187 40 117 45 110 92 32 46 203 180 206 116 21 232 155 239 238 173 101 160 31 88 86 209 242 179 43 205 156 79 144 125 59 121 89 101 163 41 74 7 251 252 216 47 33 106 162 6 11 182 72 14 143 199 19 115 25 199 100 204 120 179 88 17 68 111 249 20 62 58 197 220 207 194 129 30 151 16 161 172 107 225 196 95 199 211 27 218 85 109 20 213 205 70 119 221 10 129 194 188 160 177 203 252 14 49 206 82 6 129 49 234 182 104 152 14 87 18 115 41 23 111 197 222 68 4 7 50 101 23 157 121 45 64 128 153 79 148 73 254 103 211 91 148 37 216 28 10 6 42 119 29 76 253 153 116 147 114 2 138 118 222 10 207 185 6 19 43 253 65 162 149 3 185 233 70 149 97 75 253 6 206 129 195 121 24 86 65 158 5 248 161 104 176 161 32 219 132 196 85 56 212 83 56 22 64 217 131 39 48 144 86 131 196 41 184 66 2 60 14 183 28 76 4 162 231 97 118 70 150 224 201 52 241 237 86 85 125 160 32 134 223 144 194 37 168 227 8 213 201 168 30 141 104 145 55 230 151 34 84 135 211 126 3 110 168 66 132 167 249 232 26 154 212 221 165 30 118 55 149 169 228 75 197 189 216 212 32 12 28 128 155 96 132 66 240 197 97 31 5 167 95 131 14 64 147 143 3 107 250 88 28 99 77 114 120 32 145 75 5 181 32 159 139 14 128 0 4 122 10 248 33 157 201 77 234 160 155 206 29 8 101 148 126 65 69 98 161 186 213 119 137 150 35 228 247 210 76 172 230 35 128 89 123 102 7 164 9 66 114 58 33 88 211 17 165 222 135 218 1 116 105 118 153 22 123 161 132 250 229 233 100 143 3 254 132 56 8 96 185 81 37 223 23 75 101 153 168 170 139 22 160 233 145 23 30 203 92 141 192 33 128 172 169 185 170 230 25 155 114 86 250 38 151 62 185 56 221 127 145 50 171 161 158 13 146 103 173 171 217 18 70 152 70 28 205 250 109 156 139 146 10 96 156 166 202 155 2 156 51 29 235 39 100 124 226 248 105 168 157 54 11 35 175 75 18 247 107 9 193 246 200 223 184 82 2 42 104 54 40 99 163 77 3 136 2 55 207 53 2 56 16 51 57 50 59 43 243 204 50 231 28 51 170 40 132 67 207 205 58 167 102 194 58 63 227 60 51 186 192 158 163 179 206 14 205 114 206 203 70 67 90 224 56 75 207 60 243 71 83 38 98 202 214 163 4 208 237 125 35 236 87 75 79 142 158 240 203 79 181 48 163 2 43 62 162 45 211 3 101 251 135 224 173 175 52 150 11 221 176 200 20 119 9 180 204 141 107 196 119 227 253 182 49 39 136 56 199 29 120 228 129 120 29 96 115 226 248 227 41 100 189 184 226 135 39 222 56 228 152 99 14 73 160 183 225 65 201 36 53 45 103 46 122 230 93 132 49 15 24 167 211 131 122 59 180 142 238 186 35 6 80 33 5 1 84 208 94 69 19 77 76 247 250 238 188 247 238 251 239 192 7 47 252 240 196 23 111 252 241 50 132 0 0 33 249 4 9 6 0 23 0 44 0 0 0 0 220 0 33 0 132 84 86 84 172 174 172 212 214 212 140 138 140 188 190 188 236 234 236 108 110 108 180 182 180 164 162 164 244 246 244 100 98 100 228 230 228 204 202 204 180 178 180 220 222 220 148 150 148 196 194 196 236 238 236 124 126 124 188 186 188 164 166 164 252 250 252 108 106 108 255 255 255 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 5 254 224 37 142 100 105 158 104 170 174 108 235 190 112 44 207 116 109 223 120 174 239 124 239 255 192 160 112 72 44 26 143 200 36 13 97 105 58 159 208 168 51 162 172 90 175 180 135 98 192 237 122 191 96 9 160 128 45 155 207 164 135 129 192 110 187 223 112 202 24 77 175 39 213 16 8 65 207 223 251 251 125 114 100 118 132 133 63 120 127 126 137 137 124 130 134 143 144 55 136 122 19 19 4 7 4 19 152 153 156 108 122 142 38 17 11 163 164 165 164 21 44 21 166 171 163 84 44 17 5 172 166 168 43 170 178 165 174 43 176 183 167 169 188 164 185 42 187 191 180 37 120 122 4 1 1 13 203 205 204 202 13 7 141 115 38 2 124 128 123 124 9 44 9 128 215 217 4 2 45 214 127 223 121 4 219 43 221 224 231 237 16 226 44 228 230 223 233 42 235 238 229 225 227 222 236 122 245 105 6 250 52 176 4 167 77 52 63 160 74 8 96 64 42 214 2 135 5 28 160 75 69 192 1 196 134 163 24 192 91 177 240 33 70 143 14 32 252 67 209 205 193 168 139 30 254 53 142 99 232 208 35 72 145 220 32 152 116 25 203 161 202 120 12 105 158 92 16 114 164 136 73 201 8 182 177 52 1 194 132 104 124 16 80 83 200 160 102 41 135 61 99 154 68 121 242 38 199 156 78 93 90 243 105 34 193 132 169 59 91 90 85 209 209 35 202 173 220 190 186 52 85 96 108 138 133 45 207 194 52 113 44 211 193 78 70 9 34 101 147 144 68 89 179 165 28 76 40 150 194 235 204 184 164 220 162 128 187 182 161 96 194 36 101 178 178 185 145 108 83 89 17 7 75 125 138 81 241 137 191 171 50 67 254 25 176 40 129 129 158 42 9 61 42 109 143 210 65 76 27 187 140 170 78 242 199 148 149 223 178 188 205 115 174 61 181 128 27 122 174 182 91 103 111 174 37 12 239 92 190 96 120 108 167 89 105 27 11 216 38 128 106 161 157 246 66 232 59 226 111 214 135 143 211 90 148 157 49 247 226 156 108 71 133 175 45 160 37 115 231 126 177 178 90 111 239 29 226 82 240 187 163 159 175 153 110 192 60 172 181 97 84 38 3 106 247 218 103 197 125 254 36 93 97 182 97 68 217 74 23 93 68 95 97 192 53 22 75 126 34 116 132 88 77 19 146 84 97 88 229 65 104 92 44 29 146 54 224 105 149 100 66 80 138 172 33 195 93 134 9 98 84 98 87 192 109 216 156 121 8 202 6 85 127 245 129 21 220 141 43 165 7 18 143 12 130 133 82 91 56 18 199 153 99 68 142 0 148 117 110 156 200 134 129 75 197 183 28 116 51 38 215 96 86 177 188 19 164 131 67 142 70 227 97 32 34 41 226 125 60 53 121 130 114 31 61 136 19 151 179 169 121 65 93 167 97 66 212 138 70 29 208 218 118 85 234 23 26 41 89 146 96 216 145 85 37 201 20 156 39 5 58 66 73 96 122 228 37 78 141 146 40 167 150 100 66 7 36 164 109 130 39 231 36 71 85 114 98 81 41 238 69 192 129 74 222 38 169 152 148 150 233 168 161 86 94 25 166 120 193 65 132 225 5 26 166 39 26 172 84 133 8 41 154 105 138 249 36 139 108 172 166 221 139 180 94 102 227 130 30 250 184 150 153 111 102 218 107 76 237 57 59 43 99 39 208 69 55 169 160 246 185 122 33 171 126 2 230 212 140 156 62 211 0 51 227 58 19 192 158 164 42 100 137 81 121 181 91 9 170 216 130 42 47 187 149 112 155 33 189 244 130 106 20 188 139 226 235 233 191 19 216 75 171 191 250 130 202 175 8 221 200 91 48 187 2 91 83 240 191 236 114 133 135 105 215 29 112 93 37 22 155 6 65 186 36 12 195 28 68 7 95 80 1 161 79 5 147 194 46 238 185 183 64 200 170 164 124 165 201 40 12 243 93 41 44 155 165 50 48 45 120 204 92 47 254 181 35 32 28 125 32 212 103 36 68 23 157 194 196 243 228 225 179 59 28 27 237 244 211 115 82 135 12 50 81 50 194 215 208 80 103 253 136 22 96 116 237 181 24 176 105 45 182 33 76 72 209 132 1 102 67 17 246 216 108 183 237 246 219 112 199 45 247 220 116 215 109 247 221 120 179 16 2 0 33 249 4 9 6 0 30 0 44 0 0 0 0 220 0 33 0 132 84 86 84 172 170 172 212 214 212 196 194 196 140 138 140 236 234 236 180 182 180 108 110 108 228 226 228 204 206 204 156 158 156 244 246 244 100 98 100 180 178 180 220 222 220 204 202 204 188 190 188 164 166 164 172 174 172 220 218 220 196 198 196 148 150 148 236 238 236 188 186 188 124 126 124 228 230 228 212 210 212 164 162 164 252 250 252 108 106 108 255 255 255 0 0 0 5 254 160 39 142 100 105 158 104 170 174 108 235 190 112 44 207 116 109 223 120 174 239 124 239 255 192 160 112 72 44 26 143 200 36 109 211 105 58 159 208 168 211 226 89 52 12 215 70 22 203 205 106 187 88 141 114 76 54 86 24 132 180 122 205 110 99 0 133 106 0 50 160 80 234 248 187 222 158 175 75 30 101 129 130 61 21 7 16 135 6 136 138 16 137 140 139 17 112 85 17 26 14 14 8 149 151 150 152 155 154 150 6 128 131 161 162 51 133 3 27 10 167 168 10 170 172 171 170 6 27 145 11 1 148 153 156 153 184 156 23 20 163 189 190 43 165 17 1 6 196 197 198 199 6 10 13 144 113 179 9 149 150 8 19 150 211 155 210 151 19 151 159 191 220 221 34 165 27 18 23 227 228 229 230 23 27 203 178 180 212 2 26 9 239 26 242 240 244 26 217 158 160 37 28 25 252 253 254 253 84 88 88 40 240 175 96 6 14 44 246 25 252 23 112 197 192 133 254 16 174 80 8 145 95 67 21 15 43 30 60 1 78 92 34 114 31 201 65 184 48 82 1 44 89 147 254 48 81 24 103 224 66 203 151 46 93 86 67 176 205 196 130 1 116 232 224 28 176 19 167 128 22 19 114 242 212 73 116 192 2 22 55 139 246 212 249 147 69 208 165 67 163 30 93 145 52 234 78 162 19 90 8 16 170 52 231 212 18 29 73 186 60 4 114 36 75 8 38 153 201 73 112 9 1 78 121 238 228 201 125 119 97 154 180 154 37 22 64 112 64 48 67 95 191 8 50 60 104 186 98 2 133 2 129 1 251 229 23 244 107 10 14 16 38 240 67 188 24 240 96 173 15 250 33 232 75 185 113 194 200 147 3 35 238 123 217 105 230 202 156 165 25 229 120 192 148 56 146 102 197 142 108 68 50 157 90 103 153 30 64 112 199 91 128 111 119 9 234 98 194 75 226 166 100 202 4 55 251 165 144 149 133 134 204 4 41 79 206 48 97 53 213 1 199 167 75 47 189 66 0 244 212 139 29 88 87 97 188 242 191 2 220 85 120 15 61 122 178 103 19 97 67 126 252 24 251 130 178 219 1 158 93 210 173 129 247 92 224 23 8 160 9 113 35 232 229 0 106 168 49 254 135 89 104 139 245 245 30 121 23 28 24 157 104 139 165 151 130 97 200 81 72 208 131 41 44 16 97 131 32 34 96 33 10 235 137 150 152 131 227 145 16 214 108 100 145 53 142 35 104 157 212 12 59 150 240 212 223 141 190 221 24 220 76 4 138 96 220 104 38 146 70 152 122 208 77 55 157 120 142 161 0 217 4 210 129 55 226 9 235 113 198 94 117 73 158 176 100 147 155 41 247 164 9 24 34 7 34 135 35 132 37 150 57 137 208 134 142 58 205 164 116 9 5 16 220 232 38 111 59 106 114 65 62 197 237 165 221 137 34 14 153 194 122 138 77 72 29 4 85 218 132 29 106 202 45 167 39 10 134 49 40 221 159 129 230 53 168 159 149 109 89 130 119 20 106 230 23 152 223 180 22 206 88 36 149 57 82 125 246 25 128 31 91 150 220 129 227 169 222 5 152 73 143 85 96 7 94 116 130 29 122 2 134 70 34 71 37 82 160 65 90 161 172 38 120 39 37 136 72 226 122 156 134 147 41 200 66 148 147 181 71 93 138 97 106 42 14 139 159 150 227 72 168 177 254 204 168 223 4 252 161 170 163 112 151 204 121 130 129 125 50 40 41 9 81 86 234 32 160 159 73 120 34 114 20 240 90 2 173 128 121 137 169 9 144 29 136 32 101 227 142 64 235 162 139 205 43 38 168 211 70 107 219 58 148 148 186 27 170 112 26 48 83 3 116 22 248 104 131 20 26 219 221 105 94 134 199 236 183 131 130 24 169 187 228 66 103 238 165 23 11 202 100 173 90 114 60 2 159 32 82 22 44 124 206 150 213 41 89 242 165 133 82 45 134 13 0 215 155 243 112 235 0 171 6 242 203 153 196 68 166 172 92 1 243 58 58 44 172 187 2 117 88 161 169 57 128 238 117 217 41 86 108 115 19 107 220 158 191 45 155 25 146 88 141 12 60 163 61 6 251 135 106 156 248 96 156 221 132 209 181 171 116 134 253 32 86 52 9 28 212 101 222 208 121 42 221 182 162 111 143 16 183 100 241 130 152 175 8 240 74 13 114 160 43 158 21 27 125 227 152 84 237 90 109 153 170 45 128 2 100 226 173 77 118 178 109 153 201 34 32 107 245 173 84 237 213 158 147 254 152 123 224 107 188 149 174 76 158 231 254 52 9 244 158 69 126 206 216 211 96 181 252 178 89 209 190 24 234 168 185 193 164 59 75 58 243 188 211 5 56 113 69 71 232 65 9 5 124 78 135 192 254 24 29 176 13 112 188 80 196 31 18 60 87 193 55 10 55 243 191 11 79 181 122 210 147 244 251 85 132 203 94 123 72 177 65 224 245 90 237 196 83 207 250 5 151 77 111 6 137 73 109 226 69 41 12 20 88 252 65 110 52 81 219 241 75 135 0 253 40 176 31 131 224 23 26 137 168 128 34 4 92 20 98 0 120 2 1 246 37 126 240 43 128 1 85 164 169 97 108 225 10 92 200 224 21 238 51 179 107 112 162 19 185 192 196 4 38 231 141 18 138 2 28 171 72 197 41 86 232 10 87 156 66 70 114 104 95 46 102 104 141 105 176 202 132 56 76 66 41 96 195 195 22 37 47 121 222 91 28 110 64 120 15 26 82 195 125 57 76 162 18 206 208 134 38 58 241 13 105 2 30 79 166 120 135 41 90 145 138 119 96 152 18 183 136 4 38 72 225 139 95 108 36 6 6 137 129 193 45 24 163 140 88 184 66 2 184 200 198 54 186 241 141 112 140 163 28 231 72 199 58 218 241 142 120 44 67 8 0 0 33 249 4 9 6 0 28 0 44 0 0 0 0 220 0 33 0 132 84 86 84 172 170 172 212 214 212 140 138 140 196 194 196 236 234 236 180 182 180 108 110 108 156 158 156 228 230 228 212 210 212 244 246 244 100 98 100 180 178 180 220 222 220 204 202 204 188 190 188 164 166 164 172 174 172 220 218 220 148 150 148 196 198 196 236 238 236 188 186 188 124 126 124 164 162 164 252 250 252 108 106 108 255 255 255 0 0 0 0 0 0 0 0 0 5 254 32 39 142 100 105 158 104 170 174 108 235 190 112 44 207 116 109 223 120 174 239 124 239 255 192 160 112 72 44 26 143 200 36 77 209 104 24 156 208 232 115 10 165 46 56 150 141 118 203 237 122 183 25 165 120 108 124 72 42 4 180 122 157 110 171 211 144 192 181 0 192 12 238 248 188 126 207 160 144 255 128 61 15 6 14 19 10 2 136 137 138 139 136 134 114 28 9 0 25 16 148 149 150 151 152 7 126 129 156 157 51 131 14 8 20 163 164 165 166 164 4 10 17 115 0 17 4 4 16 176 178 177 148 179 182 154 158 185 186 43 15 23 14 25 1 23 194 195 196 197 23 20 169 143 116 147 182 180 205 205 184 187 210 211 28 160 8 18 15 217 218 219 220 15 200 170 172 25 176 148 194 16 23 6 230 231 230 232 206 209 37 26 9 241 242 243 242 22 45 22 5 244 250 9 26 44 240 251 244 236 177 192 7 112 94 191 21 255 10 198 19 184 130 160 66 126 39 64 101 192 246 160 66 54 139 23 183 89 252 246 40 82 132 88 4 12 72 24 217 64 66 73 147 40 254 27 180 219 84 98 193 43 144 48 95 18 16 208 98 130 51 89 56 99 93 89 225 50 102 206 87 52 89 216 252 249 115 167 138 158 50 109 193 154 208 66 128 51 159 180 140 146 232 245 139 34 55 140 21 183 125 91 197 97 153 44 3 236 48 145 147 176 242 132 6 95 241 242 37 80 187 182 2 83 22 2 30 204 83 171 214 166 84 20 26 32 76 72 203 119 109 130 7 65 87 196 157 219 215 174 63 189 125 243 169 5 92 83 174 223 199 249 38 16 184 43 194 90 3 139 88 187 105 77 22 238 171 74 2 23 204 137 78 167 146 150 59 18 46 39 176 165 27 143 49 92 185 138 33 39 144 76 217 68 106 217 108 93 11 134 205 218 47 109 22 183 217 206 213 173 98 176 223 216 241 12 155 144 24 64 115 55 140 20 32 128 235 42 201 243 48 177 23 200 202 58 61 98 1 4 7 107 87 167 117 219 20 246 190 2 202 143 162 21 254 152 120 138 9 21 216 203 67 15 161 118 203 245 199 231 185 71 1 95 190 226 223 203 17 130 192 101 87 101 196 13 5 21 40 254 160 140 36 180 60 97 9 104 230 128 150 93 89 38 228 165 218 124 244 236 119 66 127 24 62 6 160 10 22 198 38 92 1 26 154 96 156 120 145 77 118 216 133 132 229 83 98 9 39 246 149 92 125 17 249 50 81 86 25 97 133 89 54 209 77 71 135 43 177 56 152 78 104 18 154 163 93 44 220 137 112 219 99 124 21 64 192 91 43 40 224 152 124 179 209 200 211 147 250 228 22 88 113 142 117 56 163 125 168 97 137 156 126 91 190 215 229 136 179 169 24 96 40 4 226 168 13 70 88 33 168 224 21 145 136 19 164 74 23 192 18 90 104 164 17 9 65 146 28 156 229 0 154 105 189 72 194 96 226 249 166 230 81 122 137 136 161 161 35 76 96 158 108 105 130 217 29 98 40 182 6 165 10 82 50 57 87 122 83 17 2 204 115 111 150 42 39 87 203 52 136 39 159 123 142 69 97 75 88 122 186 152 2 229 101 41 207 135 41 88 40 171 60 144 138 208 41 97 138 90 42 130 174 50 22 90 38 10 198 53 121 235 162 83 249 50 96 102 21 8 128 153 180 90 254 37 136 106 43 158 93 194 103 58 71 18 0 168 119 44 34 231 226 177 27 78 202 26 122 204 162 16 28 61 139 109 154 2 162 148 162 43 44 7 169 21 128 230 184 141 49 201 26 174 35 72 100 85 142 6 70 91 193 169 157 221 25 75 57 7 147 211 128 159 128 230 53 40 187 188 186 139 194 175 189 165 56 239 146 142 226 43 84 124 29 214 117 193 65 234 237 133 97 110 18 159 208 169 184 105 241 91 153 128 109 186 41 112 69 212 246 40 1 157 12 194 226 32 159 69 14 211 237 183 98 42 155 207 147 181 102 90 41 112 190 80 185 86 175 28 192 23 239 90 42 219 214 115 139 64 191 6 108 93 233 86 102 99 115 208 26 136 35 193 212 1 25 82 105 123 110 107 228 171 168 21 61 245 95 37 155 64 241 200 67 95 185 87 198 173 209 42 84 151 249 37 87 181 109 141 230 23 219 3 105 195 104 110 126 19 124 28 17 203 87 81 123 17 181 3 91 91 240 215 77 148 228 120 19 38 45 108 26 75 36 104 0 218 229 121 10 35 225 76 53 29 140 249 48 211 151 95 12 225 231 152 115 14 151 231 154 103 30 58 112 227 144 158 122 223 135 162 158 121 234 119 51 231 50 156 210 198 169 56 117 204 172 115 206 48 6 252 254 59 217 35 36 148 168 95 12 169 96 65 139 246 242 5 114 174 50 202 151 124 10 14 141 105 144 63 231 205 53 61 10 14 233 123 253 114 206 6 32 214 248 16 112 253 227 83 179 160 79 203 228 212 180 159 139 68 167 196 111 138 116 51 67 82 157 250 207 160 15 168 251 252 39 1 138 0 10 56 196 33 24 65 64 7 248 168 102 248 75 224 43 246 215 191 6 18 225 1 13 112 67 27 220 80 129 10 90 16 2 104 160 196 130 236 176 135 14 118 176 15 14 12 33 18 152 64 5 41 64 65 2 79 64 33 88 86 216 128 57 124 225 133 48 68 128 8 103 72 195 26 218 240 134 56 204 161 14 119 200 195 30 250 240 135 100 8 1 0 33 249 4 9 6 0 30 0 44 0 0 0 0 220 0 33 0 132 84 86 84 172 170 172 212 214 212 196 194 196 140 138 140 236 234 236 180 182 180 108 110 108 228 226 228 204 206 204 156 158 156 244 246 244 100 98 100 180 178 180 220 222 220 204 202 204 188 190 188 164 166 164 172 174 172 220 218 220 196 198 196 148 150 148 236 238 236 188 186 188 124 126 124 228 230 228 212 210 212 164 162 164 252 250 252 108 106 108 255 255 255 0 0 0 5 254 160 39 142 100 105 158 104 170 174 108 235 190 112 44 207 116 109 223 120 174 239 124 239 255 192 160 112 72 44 26 143 200 164 178 100 233 56 159 208 168 244 185 17 37 12 141 6 118 171 205 114 191 222 197 114 76 22 22 0 24 130 122 205 110 187 25 21 209 67 66 161 12 236 248 123 126 127 135 4 196 101 129 130 11 132 133 134 135 134 28 36 25 0 27 16 16 6 143 145 147 144 146 150 143 7 113 30 15 6 8 14 158 159 14 161 163 164 158 26 127 130 169 100 13 1 173 174 175 176 174 14 36 103 17 13 10 27 10 184 187 185 185 187 187 17 16 153 114 157 162 160 199 19 161 158 203 162 26 17 128 170 209 71 6 23 9 26 214 216 215 218 217 17 179 35 103 27 6 225 6 228 229 230 231 1 27 3 195 155 6 159 201 204 8 240 198 201 162 159 9 168 210 250 68 13 20 14 19 2 0 10 12 72 112 66 178 0 222 68 128 187 117 161 161 195 135 16 47 72 8 198 238 193 5 122 219 50 102 19 32 207 193 41 104 36 44 100 24 73 178 36 73 69 43 254 56 152 92 57 210 66 11 11 5 88 154 68 169 66 165 204 146 46 89 192 188 121 82 69 191 9 9 18 60 8 58 84 40 81 107 14 16 210 2 96 107 67 195 72 79 33 61 132 42 65 93 197 98 255 168 81 187 176 117 107 67 10 203 240 129 28 49 1 194 128 1 102 209 158 77 11 97 236 137 5 106 227 178 61 43 160 69 89 185 107 243 186 53 1 119 174 90 182 19 90 8 48 75 56 239 223 189 35 12 12 112 144 32 160 193 199 144 145 42 253 214 232 22 132 11 151 49 95 222 28 41 243 68 97 154 56 133 154 112 225 129 134 211 2 52 164 62 173 1 2 216 100 31 79 8 120 48 178 0 130 12 182 113 103 152 48 0 49 9 184 19 106 223 142 137 27 193 131 186 44 102 147 68 64 60 119 89 223 35 56 64 8 94 188 56 241 227 118 105 235 222 110 155 55 116 197 14 142 63 118 236 24 40 199 201 10 153 54 112 218 80 170 195 206 15 171 174 11 125 1 222 4 3 141 87 167 22 192 127 240 131 9 166 60 35 27 109 182 17 183 221 115 44 72 254 23 92 115 213 101 128 93 114 4 54 55 92 6 14 244 198 2 112 219 153 84 192 131 43 40 103 29 115 181 33 152 2 120 9 24 20 208 63 2 160 232 145 6 73 37 228 193 66 10 84 130 25 84 143 68 133 153 124 87 189 67 154 53 252 169 230 163 106 174 217 19 155 9 30 74 168 155 119 23 78 167 91 110 49 197 196 161 10 19 80 192 228 132 49 137 168 194 2 23 45 169 165 113 200 117 72 219 112 183 29 104 225 136 139 137 103 226 63 0 253 35 153 139 181 172 135 25 87 53 194 249 230 101 6 124 118 85 71 247 241 232 227 126 170 221 129 128 41 249 148 160 28 147 220 89 153 130 130 6 26 249 100 10 131 214 38 92 1 72 166 52 93 110 31 58 217 37 148 82 18 218 228 110 109 249 68 129 121 2 165 57 222 105 45 46 181 129 101 17 197 25 21 4 56 134 230 142 39 59 238 41 107 107 15 24 35 214 128 19 86 103 155 3 157 174 128 225 148 205 81 112 105 10 81 10 215 32 167 208 137 240 107 131 215 13 139 194 108 185 142 52 156 161 38 254 128 103 38 100 41 26 212 88 169 148 53 37 103 37 52 194 39 145 85 244 141 134 31 159 232 14 6 86 51 129 146 48 40 115 209 70 122 165 146 77 134 169 219 162 207 62 192 160 150 21 38 235 193 2 244 82 89 219 167 130 17 88 91 129 35 201 123 194 79 37 166 153 237 64 170 113 155 222 169 49 218 152 153 184 13 181 74 12 61 213 252 136 174 6 119 188 227 204 94 30 58 186 36 181 39 40 200 44 147 194 218 37 229 163 19 162 108 130 116 14 152 92 175 131 206 158 16 229 205 36 85 217 43 10 214 150 39 106 50 230 73 252 162 122 236 169 186 153 67 149 84 5 26 49 120 226 167 26 159 123 66 240 223 61 237 146 245 242 166 8 43 140 2 134 90 110 135 239 128 186 58 10 233 152 87 14 48 193 190 8 143 77 164 118 90 230 214 175 167 160 150 151 34 65 164 162 119 116 56 10 200 41 39 84 52 74 20 193 124 114 212 7 107 199 233 250 104 181 49 67 10 74 32 152 61 203 92 194 178 8 223 155 179 9 59 131 200 157 39 63 167 176 236 177 254 5 16 12 97 216 93 119 94 109 153 118 163 153 102 99 8 232 189 144 35 76 183 39 123 124 228 110 252 137 0 136 207 154 218 89 160 220 250 118 174 155 238 134 182 231 1 247 92 156 219 37 20 107 243 180 166 167 92 223 163 90 34 79 194 206 61 219 123 246 119 139 149 232 152 3 4 161 185 173 235 234 245 45 35 184 153 129 235 244 157 68 231 254 177 186 203 140 172 243 214 32 150 238 47 162 164 223 38 253 8 179 213 75 40 133 195 127 13 129 3 6 98 150 232 188 180 164 248 37 172 121 36 176 86 81 130 194 192 6 178 8 124 225 96 207 140 150 54 193 205 76 132 112 155 184 200 59 188 242 20 174 60 196 31 242 104 156 187 208 242 8 18 22 198 44 254 234 75 9 205 114 129 1 96 6 45 151 75 222 10 87 248 23 4 150 64 58 46 84 203 11 9 51 29 193 148 112 135 57 36 12 116 250 129 162 129 152 40 84 7 97 83 101 42 134 177 192 57 68 99 237 232 136 71 130 114 141 108 48 80 53 29 113 159 9 68 66 169 99 141 132 38 135 50 212 150 189 182 147 147 21 192 4 114 210 18 14 24 81 96 147 52 118 209 54 101 84 193 25 183 51 70 230 172 177 4 212 96 141 53 78 179 71 62 178 6 124 182 80 64 57 186 48 200 45 144 131 21 142 200 145 20 143 49 138 101 212 3 80 254 218 135 36 107 96 128 0 68 192 21 151 108 197 37 51 185 73 9 40 49 130 188 8 165 47 70 169 128 193 85 68 131 241 48 70 35 85 137 181 72 78 242 149 48 64 132 44 17 1 70 70 4 99 78 184 220 140 46 223 132 65 78 44 114 30 246 232 72 42 69 8 203 98 146 225 12 105 112 131 50 149 9 7 57 72 224 14 103 129 230 89 236 48 205 104 90 211 15 174 52 166 54 127 80 128 41 120 243 155 10 16 129 6 8 137 5 66 122 1 12 92 104 64 54 183 201 206 118 186 243 157 240 140 167 60 231 73 207 122 218 243 158 248 28 67 8 0 0 33 249 4 9 6 0 31 0 44 0 0 0 0 220 0 33 0 132 84 86 84 172 174 172 220 218 220 140 138 140 196 198 196 236 238 236 188 186 188 156 158 156 108 110 108 228 230 228 212 210 212 252 250 252 164 166 164 100 98 100 180 182 180 228 226 228 204 206 204 196 194 196 180 178 180 220 222 220 148 150 148 204 202 204 244 246 244 188 190 188 164 162 164 124 126 124 236 234 236 212 214 212 252 254 252 172 170 172 108 106 108 255 255 255 5 254 224 39 142 100 105 158 104 170 174 108 235 190 112 44 207 116 109 223 120 174 239 124 239 255 192 160 112 72 44 26 143 200 164 178 100 113 72 156 208 167 52 42 153 74 21 34 140 103 203 237 122 191 220 194 114 76 22 90 58 151 8 65 205 94 187 213 111 119 160 34 162 52 6 248 188 126 207 207 0 18 101 129 130 31 11 11 22 133 135 134 136 139 138 28 36 103 16 2 27 147 148 149 150 149 15 14 116 31 20 8 23 159 160 161 162 163 12 0 26 131 168 75 146 27 10 172 174 175 173 174 10 98 35 103 10 17 20 185 186 187 188 186 7 153 155 157 17 105 196 195 198 197 196 23 4 23 165 167 169 207 70 27 19 26 9 9 212 212 214 213 216 212 27 180 34 144 184 6 226 227 228 229 6 29 7 2 6 4 117 8 199 199 200 199 203 195 205 208 246 67 2 15 26 19 15 252 254 253 0 39 36 40 48 235 81 135 91 20 42 40 92 200 176 97 133 0 24 38 104 106 7 207 192 5 113 23 28 92 220 104 49 77 4 12 166 78 20 168 70 178 100 201 5 44 254 22 152 92 89 205 155 138 2 216 88 146 68 185 66 165 204 146 46 83 192 188 57 83 197 6 125 4 42 16 24 26 180 168 208 10 221 4 184 4 151 240 168 81 163 66 33 60 252 53 145 147 59 98 1 36 4 216 170 85 235 214 173 14 134 49 11 105 98 67 4 99 104 61 166 177 192 194 66 218 179 106 207 110 104 33 160 216 91 99 108 87 184 141 251 110 152 128 22 27 226 189 189 144 23 133 128 105 4 242 61 88 188 152 223 98 8 221 10 214 234 0 129 64 194 160 11 165 42 148 74 128 179 132 3 19 12 4 187 26 193 192 147 81 29 35 60 49 86 175 108 5 107 15 96 103 75 80 183 112 138 5 23 4 104 139 189 237 1 82 192 175 171 233 219 77 155 112 202 220 196 53 12 79 240 155 133 128 224 219 118 11 136 96 219 196 97 13 4 252 37 0 24 48 82 129 110 6 17 42 236 76 62 42 230 133 1 126 73 24 109 204 64 128 212 29 211 88 92 157 6 164 179 18 27 160 107 219 63 189 250 9 183 186 69 167 92 53 205 173 144 159 53 189 101 254 51 1 117 109 69 16 32 75 26 20 232 19 116 250 44 167 65 109 42 228 195 156 98 253 108 23 219 99 145 45 69 25 46 71 49 164 153 121 149 125 38 17 123 160 72 128 145 69 6 148 6 35 125 99 221 71 194 129 3 146 52 224 4 198 233 101 128 64 215 240 150 141 132 41 8 64 192 128 72 102 131 161 143 64 102 115 205 118 68 162 112 32 111 177 205 214 159 79 64 29 230 97 64 219 65 86 128 0 54 218 66 34 138 69 85 118 34 1 159 1 67 17 86 241 93 212 38 125 31 145 133 159 126 26 68 119 101 77 185 229 152 96 148 39 224 184 31 108 23 50 136 39 152 85 42 103 40 115 115 57 119 100 146 79 46 105 216 4 5 100 215 33 63 219 57 22 137 6 146 125 51 98 83 81 45 212 217 120 154 165 167 166 85 112 153 166 81 140 241 117 4 103 107 115 18 39 219 133 61 170 0 224 108 135 90 67 64 162 43 24 153 92 149 197 249 103 194 172 65 254 201 167 107 66 146 196 155 163 39 92 151 24 99 147 86 10 193 44 224 77 38 222 167 78 254 105 246 105 103 162 86 37 140 124 46 110 244 9 170 23 193 105 95 159 175 37 105 165 160 178 34 23 236 126 195 206 25 157 147 9 44 232 43 19 234 10 185 77 98 192 209 90 235 157 134 1 53 129 64 2 49 102 169 82 153 126 192 212 120 155 85 192 25 103 232 129 182 14 69 168 190 215 209 139 242 57 16 86 125 114 222 24 156 147 66 34 139 2 110 64 22 138 228 173 116 29 185 91 146 30 159 0 242 159 193 182 75 130 145 235 242 23 107 159 177 85 192 33 192 91 122 9 102 120 36 94 91 173 167 41 170 199 226 48 167 93 84 218 183 159 136 155 241 8 126 14 215 40 186 41 204 10 239 108 46 51 93 110 177 215 240 27 181 131 239 30 90 181 8 7 238 23 172 188 25 66 154 24 206 2 247 227 93 193 7 103 166 176 167 111 43 148 94 104 67 187 103 209 209 159 28 109 42 107 75 131 173 159 108 214 164 252 171 131 128 210 138 104 201 181 246 198 227 188 143 16 158 160 54 248 178 224 103 111 212 8 62 66 62 216 57 214 88 99 93 206 194 246 65 254 61 151 87 38 153 105 106 123 85 210 227 112 148 26 141 227 186 86 248 159 90 163 96 129 186 198 6 249 245 7 186 178 124 236 204 31 27 160 91 225 79 222 14 179 142 188 6 202 248 7 63 37 176 172 99 241 122 56 129 119 209 106 10 1 137 39 90 123 226 120 42 154 222 222 123 168 185 185 106 223 200 83 24 100 229 188 171 156 167 211 196 221 158 223 248 197 146 173 215 5 211 148 164 103 228 6 150 11 124 53 150 139 112 88 1 66 21 53 84 255 69 9 17 207 46 99 158 183 149 233 83 217 98 79 140 46 208 149 172 84 161 43 93 209 8 61 192 23 24 188 137 229 29 199 251 134 88 228 211 30 98 224 42 67 121 3 197 59 62 145 65 66 112 80 62 200 200 13 96 242 118 183 19 14 227 120 249 40 128 63 254 241 175 128 104 224 75 97 218 20 168 16 70 173 78 37 112 77 195 16 135 3 132 104 128 33 14 177 136 197 104 93 9 96 130 53 94 85 131 38 42 176 73 142 228 215 146 22 48 17 112 219 217 13 20 111 83 18 42 17 47 39 40 184 177 34 54 156 168 143 45 150 37 126 79 74 35 188 62 135 144 84 141 2 20 22 65 7 221 214 148 12 120 140 240 24 172 186 135 30 121 32 9 5 180 226 143 176 96 133 31 91 33 162 233 245 226 144 188 16 26 16 227 18 15 193 40 113 143 144 196 129 34 18 65 73 70 36 162 16 225 89 5 32 255 56 72 63 202 226 39 218 187 99 35 47 248 137 60 70 242 148 75 176 0 3 210 16 135 54 16 165 149 103 89 79 29 238 192 135 90 214 210 15 54 66 165 46 143 96 1 43 72 193 151 191 132 130 19 36 0 129 44 120 160 1 91 64 230 49 185 160 204 100 34 128 153 91 200 229 46 167 73 205 106 90 243 154 216 204 166 54 183 201 205 110 122 243 155 72 8 1 0 33 249 4 9 6 0 29 0 44 0 0 0 0 220 0 33 0 132 84 86 84 172 170 172 212 214 212 196 194 196 140 138 140 236 234 236 180 182 180 108 110 108 204 206 204 156 158 156 228 230 228 244 246 244 100 98 100 180 178 180 220 222 220 204 202 204 188 190 188 164 166 164 172 174 172 220 218 220 196 198 196 148 150 148 236 238 236 188 186 188 124 126 124 212 210 212 164 162 164 252 250 252 108 106 108 255 255 255 0 0 0 0 0 0 5 254 96 39 142 100 105 158 104 170 174 108 235 190 112 44 207 116 109 223 120 174 239 124 239 255 192 160 112 72 44 26 143 200 164 50 168 225 56 159 208 168 244 105 233 44 26 13 67 118 171 237 110 185 220 204 114 76 30 86 24 132 180 122 205 110 99 0 10 107 0 50 160 212 239 246 124 93 159 151 60 202 128 129 29 27 11 133 134 135 136 135 37 21 7 16 16 6 142 144 143 145 148 147 142 17 0 5 114 8 10 19 14 159 160 161 162 161 23 127 130 167 74 14 1 171 172 172 17 173 173 13 139 7 3 17 26 9 9 183 184 184 186 189 184 13 152 154 11 1 8 159 10 198 200 14 199 202 201 14 165 168 208 71 170 8 25 8 212 214 25 213 218 215 16 178 36 140 3 26 1 6 228 229 230 231 6 9 6 26 153 114 25 163 240 163 199 207 209 245 41 27 10 249 250 251 250 85 41 170 14 38 76 16 48 176 32 193 131 158 6 24 152 21 78 194 133 135 16 35 74 188 160 1 88 187 5 17 222 125 154 144 173 163 71 143 158 62 209 43 129 143 159 73 5 254 254 86 88 40 112 146 223 6 22 37 91 246 107 177 82 166 190 151 43 22 12 160 179 115 64 207 159 2 84 0 172 134 224 65 209 163 72 31 56 80 200 80 131 195 135 144 46 64 120 56 117 234 5 72 9 44 10 11 160 209 193 131 137 96 61 117 26 73 66 39 207 179 62 121 6 101 49 129 14 218 159 116 22 176 48 155 182 238 217 9 45 4 184 133 107 87 110 206 1 19 242 177 84 48 56 223 131 181 40 134 102 16 200 184 241 64 4 19 40 120 27 1 206 41 85 171 81 51 59 162 168 213 74 70 80 95 63 126 252 234 201 19 217 17 11 32 4 38 44 184 245 225 188 15 246 13 30 220 214 175 138 13 170 91 179 30 252 154 109 108 214 192 89 78 24 96 59 69 106 7 179 91 179 236 157 56 128 131 106 6 29 28 148 62 65 41 211 111 180 44 95 173 90 245 50 68 117 236 182 190 59 246 96 64 54 1 25 208 171 175 118 33 164 51 83 37 116 6 78 94 152 185 10 1 177 11 36 103 61 188 56 10 249 192 241 83 128 125 41 224 167 92 128 181 205 254 5 88 112 178 81 128 215 63 206 161 231 216 64 1 61 22 217 100 34 84 230 208 102 80 89 21 209 84 234 4 227 89 87 62 157 103 162 122 15 24 32 214 4 167 137 144 218 106 133 1 71 32 10 145 197 40 91 130 57 93 160 12 75 60 238 51 227 9 53 154 196 99 127 115 65 128 156 144 134 33 118 130 98 211 9 80 225 65 144 73 214 212 83 219 89 53 137 84 81 129 119 17 87 160 65 144 94 122 235 161 135 64 123 160 180 104 5 96 61 198 56 160 146 5 254 86 88 143 68 174 128 219 4 54 246 248 163 9 6 50 168 15 142 42 0 152 166 143 108 150 160 152 64 79 86 104 161 148 216 53 228 29 150 155 69 37 85 69 34 14 83 204 39 229 157 248 165 152 42 150 9 95 89 185 9 168 207 157 37 228 169 79 140 124 26 183 96 143 252 128 74 66 117 163 202 214 9 113 10 206 215 146 170 67 65 134 144 64 78 18 20 37 134 29 104 216 33 85 16 113 248 80 136 91 106 164 64 137 151 38 59 102 96 34 109 138 218 169 168 178 166 234 8 172 254 238 71 27 172 57 229 246 166 140 15 174 144 65 126 39 21 80 234 127 70 90 43 109 183 64 70 184 152 116 1 17 196 152 0 187 78 41 21 68 144 56 74 21 36 144 94 244 25 165 23 132 105 34 123 78 54 123 194 139 186 5 56 173 8 223 122 202 31 182 183 117 26 160 96 7 119 32 234 110 123 50 108 170 172 122 210 234 92 54 141 57 73 161 0 240 94 40 47 163 221 105 6 226 58 197 130 102 222 165 97 46 171 233 192 104 134 171 64 196 65 162 122 173 127 48 211 169 166 180 129 2 9 174 110 194 89 252 223 169 174 18 6 152 80 27 219 202 46 133 184 46 134 40 101 217 61 229 33 176 221 13 107 64 164 196 40 83 93 191 201 94 154 34 179 239 13 172 45 197 188 245 108 2 171 69 7 141 179 9 0 182 90 31 186 41 36 108 179 96 113 246 105 100 209 159 194 93 194 4 234 150 230 46 211 248 45 181 80 162 150 25 176 221 225 142 102 137 178 120 93 38 219 50 153 2 179 189 224 195 231 182 144 1 5 127 238 198 34 78 125 182 71 57 143 254 71 179 48 241 126 117 95 60 55 232 122 147 192 36 161 76 15 4 175 224 242 58 194 221 188 192 62 218 25 70 93 85 234 248 151 46 71 30 159 106 59 243 38 134 111 1 38 87 250 208 24 255 249 64 234 120 254 252 231 230 69 78 53 192 5 211 63 84 253 0 102 139 80 171 53 220 119 207 189 200 132 83 57 145 102 86 99 109 108 245 134 167 127 213 250 153 250 94 214 78 116 80 47 191 252 216 231 21 255 244 248 67 52 61 231 198 237 53 255 245 237 177 95 254 230 71 191 181 145 100 91 250 105 85 74 150 228 28 92 25 228 129 132 186 14 212 20 117 56 75 204 107 42 248 186 93 214 54 114 141 109 120 112 82 238 27 65 73 204 53 19 22 212 164 96 193 225 31 10 98 66 177 0 45 48 5 39 44 222 62 84 8 4 85 100 131 26 218 200 161 7 187 209 148 113 144 35 11 229 0 67 57 178 98 62 173 129 98 25 71 76 162 214 204 100 143 38 226 64 21 176 88 197 43 2 48 197 86 12 110 130 190 200 133 22 125 113 139 91 44 110 68 71 116 121 15 51 226 97 26 103 57 241 140 54 32 68 34 214 136 8 134 92 240 141 82 217 76 119 232 16 30 119 24 67 44 240 88 198 49 58 17 54 52 250 17 16 103 104 131 32 7 249 134 173 92 192 14 62 73 100 121 6 176 72 70 38 210 145 13 48 227 31 39 105 132 38 76 225 146 82 96 0 7 170 112 133 45 92 0 11 159 108 64 40 67 137 5 81 150 178 1 195 163 164 42 87 201 202 86 186 242 149 176 140 165 44 103 73 203 90 218 18 6 33 0 0 33 249 4 9 6 0 31 0 44 0 0 0 0 220 0 33 0 132 84 86 84 172 174 172 220 218 220 140 138 140 196 198 196 236 238 236 188 186 188 156 158 156 108 110 108 228 230 228 212 210 212 252 250 252 164 166 164 100 98 100 180 182 180 228 226 228 204 206 204 196 194 196 180 178 180 220 222 220 148 150 148 204 202 204 244 246 244 188 190 188 164 162 164 124 126 124 236 234 236 212 214 212 252 254 252 172 170 172 108 106 108 255 255 255 5 254 224 39 142 100 105 158 104 170 174 108 235 190 112 44 207 116 109 223 120 174 239 124 239 255 192 160 112 72 44 26 143 200 164 50 168 144 56 156 208 231 51 74 157 58 44 31 141 103 203 237 122 191 92 204 114 76 30 86 2 132 72 122 173 110 179 223 151 14 86 3 200 12 238 248 188 126 223 160 148 255 128 31 28 11 11 22 132 134 133 135 138 137 37 21 14 15 27 145 146 147 148 147 2 10 114 31 9 0 24 23 158 159 160 161 162 8 126 129 166 74 5 10 145 170 172 27 170 174 171 145 2 37 4 6 19 7 20 185 186 187 188 186 17 16 153 116 12 17 23 196 198 197 200 199 202 164 167 205 71 5 27 26 9 210 211 9 213 210 212 26 19 179 36 142 15 7 29 6 226 227 228 229 6 20 17 152 115 156 201 237 202 238 23 204 206 243 41 11 214 247 248 248 5 42 169 5 9 15 19 0 2 12 56 129 224 131 2 144 26 57 184 37 161 130 195 135 16 35 86 64 7 12 203 166 97 200 12 92 208 168 209 193 70 143 26 147 201 43 97 47 159 201 4 251 254 88 20 160 118 242 222 2 22 37 91 222 75 185 98 165 76 151 44 44 24 219 89 108 231 6 126 27 160 17 168 160 102 40 1 163 71 9 104 227 54 194 27 184 10 70 29 14 133 10 97 234 80 116 234 178 112 50 230 32 64 0 9 94 193 138 13 235 137 216 72 18 11 122 170 141 192 147 169 138 13 201 120 178 45 134 101 133 206 181 202 136 185 77 1 55 239 218 11 117 85 232 20 96 77 195 131 105 135 173 85 248 153 162 159 128 10 15 34 75 22 248 224 241 191 189 142 38 96 8 240 16 2 213 136 4 60 79 252 21 108 107 49 39 162 64 25 8 32 178 84 137 193 136 171 197 94 220 194 242 61 195 178 5 0 134 121 129 112 108 195 212 104 179 176 157 173 112 229 8 129 83 88 184 48 161 248 181 4 194 81 20 16 144 10 130 64 131 146 5 40 221 166 240 27 231 208 161 169 130 23 29 26 43 131 117 157 136 61 9 21 210 147 1 9 101 35 156 29 177 220 183 115 105 209 223 86 184 246 160 184 0 228 57 69 64 24 75 248 104 144 31 95 251 33 254 6 92 97 186 37 135 2 108 216 240 167 1 1 123 149 224 24 100 135 101 56 65 2 4 41 149 16 9 16 44 116 64 67 18 65 20 30 84 20 5 176 14 70 17 72 0 159 1 17 136 179 17 140 226 176 70 76 60 174 161 101 139 108 184 5 199 216 10 27 236 135 91 97 213 52 152 211 142 17 70 248 192 129 40 4 249 79 108 185 1 104 23 115 61 38 86 24 1 63 158 112 225 117 0 253 51 208 118 152 61 114 192 119 226 85 101 38 84 21 120 70 1 1 89 109 130 1 87 47 134 20 227 70 27 217 88 204 124 34 192 198 227 109 88 214 150 96 146 135 105 240 159 131 39 164 37 192 144 192 245 7 93 150 41 104 167 65 143 207 25 105 151 128 123 98 179 36 163 22 82 183 129 117 145 121 217 37 64 30 50 26 162 102 29 56 36 26 104 228 141 86 145 86 44 186 248 9 71 175 174 214 218 9 16 6 170 168 97 76 158 16 164 162 191 29 38 169 96 148 90 74 228 162 45 236 42 155 53 129 254 170 92 176 68 246 119 88 174 35 108 185 33 65 158 254 58 202 93 55 182 140 104 148 153 227 73 37 26 86 165 189 233 201 122 116 206 25 146 172 198 224 249 65 125 17 26 55 77 159 195 17 224 110 113 19 72 41 88 111 191 241 72 97 177 66 22 182 96 2 131 230 68 37 175 197 65 43 66 63 10 112 42 25 181 5 133 218 221 152 37 134 119 226 85 191 168 168 9 59 234 193 87 140 140 52 138 35 129 70 102 229 56 130 161 198 177 132 31 166 186 86 32 205 173 188 42 139 66 90 27 86 250 44 202 38 56 10 37 145 46 211 74 41 127 179 209 124 48 117 143 117 185 225 100 149 129 169 16 67 219 78 229 237 103 19 177 121 30 171 112 206 248 234 171 118 202 39 114 158 2 22 39 172 193 36 104 199 99 98 210 4 60 233 161 195 46 200 245 8 78 18 41 108 189 132 154 48 88 54 4 19 219 152 2 208 112 26 144 208 95 26 198 168 83 36 62 212 173 137 16 164 136 158 49 174 78 13 43 186 119 94 253 193 2 72 222 22 168 220 64 246 11 105 216 187 141 253 53 159 21 166 252 156 130 0 87 126 239 128 254 86 14 201 245 150 145 13 61 52 168 75 61 92 106 183 18 127 70 113 86 116 164 119 193 122 115 214 206 209 199 200 168 171 231 202 207 157 45 2 113 143 23 105 175 114 248 114 30 161 239 31 216 236 46 131 195 63 200 172 165 192 193 43 157 166 214 153 190 48 192 30 238 85 11 210 167 2 206 52 69 153 92 20 53 71 176 186 87 181 186 140 111 8 92 187 144 235 119 91 217 57 155 96 232 144 80 78 152 185 9 78 66 159 155 231 196 215 190 113 89 197 240 217 7 28 19 1 168 32 229 40 6 220 207 135 70 16 34 239 248 141 91 228 241 76 121 210 17 46 194 185 232 43 98 25 11 88 102 229 182 118 148 5 100 1 44 22 60 140 1 178 182 189 230 70 36 244 224 253 74 0 151 255 145 240 24 38 68 203 242 120 133 44 154 104 137 110 165 227 210 64 6 130 144 48 49 4 77 75 99 218 67 4 167 21 217 125 68 28 14 48 64 18 203 193 65 146 32 107 121 184 57 72 11 86 146 152 42 62 201 48 47 89 65 73 16 85 32 41 170 4 82 79 186 169 71 127 178 56 132 84 60 234 57 216 72 82 234 72 176 61 112 200 200 112 116 58 215 154 20 240 52 97 188 227 29 161 56 134 186 232 193 71 28 76 71 1 128 132 5 43 90 49 200 48 125 163 23 136 228 69 197 208 51 194 184 176 37 47 123 236 163 36 103 160 8 68 24 226 146 137 72 132 33 142 6 200 65 10 242 147 173 184 68 248 76 115 71 100 124 226 29 145 156 164 42 143 112 134 164 184 225 149 111 112 67 28 214 97 135 61 216 210 150 125 88 165 46 199 208 4 43 80 193 69 82 0 38 20 92 36 129 57 124 161 1 96 72 230 22 196 176 203 102 58 243 153 208 140 166 52 167 73 205 106 90 243 154 216 204 102 12 66 0 0 33 249 4 9 6 0 30 0 44 0 0 0 0 220 0 33 0 132 84 86 84 172 170 172 212 214 212 196 194 196 140 138 140 236 234 236 180 182 180 108 110 108 228 226 228 204 206 204 156 158 156 244 246 244 100 98 100 180 178 180 220 222 220 204 202 204 188 190 188 164 166 164 172 174 172 220 218 220 196 198 196 148 150 148 236 238 236 188 186 188 124 126 124 228 230 228 212 210 212 164 162 164 252 250 252 108 106 108 255 255 255 0 0 0 5 254 160 39 142 100 105 158 104 170 174 108 235 190 112 44 207 116 109 223 120 174 239 124 239 255 192 160 112 72 44 26 143 200 164 114 25 179 116 158 208 168 116 10 221 136 18 6 67 67 171 221 54 188 92 240 87 187 96 154 207 191 2 0 67 104 187 223 240 56 163 34 122 52 6 20 60 62 79 225 235 253 125 16 1 101 104 133 103 11 136 137 138 139 138 28 36 25 0 27 16 16 6 147 149 148 150 152 154 149 7 116 30 15 6 14 14 8 162 164 163 165 162 167 167 8 9 131 134 175 75 13 1 179 180 181 179 17 182 14 36 106 17 13 10 27 10 191 193 192 194 196 196 17 3 157 117 6 166 205 168 171 170 164 26 174 176 213 70 149 26 9 9 217 219 218 217 26 223 173 186 35 106 27 6 10 89 233 234 235 89 1 17 16 202 159 204 163 19 164 246 208 248 172 212 214 66 28 25 255 0 3 2 180 208 194 66 1 129 8 51 56 74 113 199 193 4 1 15 35 66 156 248 208 65 128 113 34 202 53 216 112 161 163 199 143 32 47 72 64 22 15 148 41 7 225 254 82 118 3 103 106 26 161 18 22 18 34 92 168 194 159 204 128 4 89 24 188 9 144 102 138 5 3 32 12 8 58 84 40 209 1 2 90 76 184 96 84 168 211 162 3 94 158 48 64 97 130 182 7 218 178 94 245 134 224 226 46 0 189 20 64 8 217 177 18 72 9 27 146 121 2 117 106 169 129 178 23 222 194 165 122 74 67 4 169 35 38 52 133 122 20 2 222 19 64 247 18 109 58 161 133 128 167 130 157 254 53 1 116 194 191 2 8 50 64 6 248 32 41 11 1 15 0 78 62 40 89 239 226 17 13 170 38 128 56 161 180 105 211 219 44 98 244 160 145 35 211 215 154 58 98 18 41 169 228 133 182 6 182 129 211 32 0 92 111 1 120 90 238 35 129 249 113 228 205 25 38 68 101 209 216 184 100 4 156 43 43 205 44 249 177 113 229 159 73 44 128 224 128 179 247 234 210 89 76 200 140 252 121 6 7 203 25 138 54 77 122 162 195 209 170 191 154 19 107 214 236 216 178 147 152 142 84 187 12 193 4 135 23 84 198 219 111 191 105 0 193 3 117 13 254 55 66 113 144 113 86 93 114 126 177 192 1 4 142 57 24 80 1 225 173 80 220 115 13 62 230 25 115 3 84 88 221 65 13 86 101 24 121 35 30 7 97 118 30 24 48 128 3 149 181 231 208 105 219 116 181 90 107 30 93 130 95 126 102 5 80 219 90 161 144 50 65 110 188 21 89 224 97 20 248 135 210 93 39 108 232 157 138 216 49 71 225 136 84 34 144 161 10 197 29 23 217 131 81 174 176 93 119 90 94 72 129 101 26 82 55 25 149 232 177 24 154 85 167 85 228 38 56 241 145 3 150 47 99 229 39 219 71 247 137 68 210 90 183 209 115 193 54 71 26 137 71 130 139 49 168 162 119 31 174 48 225 4 156 65 199 97 6 87 166 48 1 5 5 32 71 226 138 32 138 72 37 100 145 162 48 169 165 154 37 138 130 139 48 186 199 158 67 2 192 231 149 156 27 108 20 146 125 102 197 5 1 90 240 0 169 228 144 128 22 105 164 129 8 138 98 87 161 15 168 104 30 100 14 68 232 101 136 85 154 215 105 147 193 62 248 207 113 162 254 132 236 119 208 254 69 182 172 9 12 94 248 92 154 42 172 57 218 169 167 194 185 106 70 145 208 41 235 107 231 194 166 39 127 242 216 179 84 174 2 20 200 219 80 246 184 196 44 135 194 38 151 158 10 219 85 120 232 113 38 94 134 162 100 29 234 203 162 8 95 22 252 221 181 37 124 106 93 6 80 26 139 130 183 17 73 52 163 85 2 196 73 110 88 119 86 162 99 92 30 205 154 86 73 65 150 70 100 111 190 233 10 65 146 255 181 178 152 6 212 61 76 98 180 40 44 42 179 163 144 146 169 130 195 103 90 71 51 96 200 166 168 172 206 41 24 122 105 131 93 142 250 98 101 165 101 220 116 69 163 217 40 159 1 174 49 85 103 200 117 86 226 78 173 117 244 9 32 188 70 198 59 168 52 10 138 192 96 121 196 238 43 45 163 206 93 202 48 113 49 31 29 25 183 199 178 253 40 120 68 123 74 233 150 155 205 45 241 84 47 38 80 177 155 78 139 123 99 36 231 48 21 171 108 177 222 135 22 187 38 209 115 242 174 40 31 88 138 203 247 90 215 96 100 63 51 54 109 190 254 146 5 92 38 149 143 118 94 66 191 230 57 151 243 137 170 111 150 244 9 107 50 237 230 236 169 141 203 90 185 28 221 151 181 238 246 61 78 50 61 239 202 123 164 229 100 3 43 180 117 116 243 59 101 138 110 231 125 130 195 170 119 166 54 10 205 201 93 162 243 38 64 239 32 103 197 178 72 170 224 16 161 58 99 198 170 30 30 214 125 141 227 247 17 173 182 253 231 80 110 4 82 62 212 229 101 123 96 232 166 152 42 74 161 133 219 139 142 37 138 29 226 140 233 180 35 20 166 16 197 106 68 193 94 9 128 227 148 2 14 38 40 222 91 154 86 38 152 21 13 72 141 85 174 250 152 125 116 167 159 61 245 199 79 31 145 139 8 47 144 36 95 213 143 129 136 9 202 83 14 230 129 192 60 197 128 5 164 144 97 38 49 0 24 214 112 48 44 180 201 153 112 246 172 156 172 32 38 97 66 72 1 124 98 130 208 32 160 61 18 25 220 127 108 87 142 115 216 201 106 120 138 149 239 128 164 10 173 168 228 27 25 43 222 9 98 50 153 200 4 17 1 68 60 188 1 7 130 184 195 131 248 80 5 6 17 214 150 158 53 68 126 172 0 27 223 136 227 21 197 33 31 95 132 161 11 233 216 66 24 124 196 181 79 120 13 31 207 72 197 61 126 229 198 66 254 64 22 238 184 133 34 109 17 1 9 48 113 78 192 136 100 48 38 57 140 74 42 192 131 237 162 7 52 156 225 46 66 25 242 147 59 96 132 40 25 225 19 72 72 226 106 147 72 101 42 161 152 74 200 5 41 26 245 200 71 44 253 99 47 80 218 242 12 106 96 67 28 118 185 203 57 212 225 14 67 9 166 30 132 25 204 60 12 133 2 23 168 223 45 151 73 132 2 80 225 153 208 84 128 8 52 48 6 61 222 209 154 119 196 35 11 153 201 205 110 122 243 155 224 12 167 56 199 73 206 114 154 243 156 252 8 1 0 33 249 4 9 6 0 31 0 44 0 0 0 0 220 0 33 0 132 84 86 84 172 174 172 220 218 220 140 138 140 196 198 196 236 238 236 188 186 188 156 158 156 108 110 108 228 230 228 212 210 212 252 250 252 164 166 164 100 98 100 180 182 180 228 226 228 204 206 204 196 194 196 180 178 180 220 222 220 148 150 148 204 202 204 244 246 244 188 190 188 164 162 164 124 126 124 236 234 236 212 214 212 252 254 252 172 170 172 108 106 108 255 255 255 5 254 224 39 142 100 105 158 104 170 174 108 235 190 112 44 207 116 109 223 120 174 239 124 239 255 192 160 112 72 44 26 143 200 164 114 25 179 56 36 207 40 116 42 165 82 21 34 140 103 203 237 122 191 220 2 115 76 254 89 58 151 8 65 205 94 187 213 111 119 160 34 162 52 6 248 188 126 207 207 0 18 101 129 101 11 11 22 132 134 133 135 138 137 28 36 103 16 2 27 146 147 148 149 148 15 14 116 31 20 8 23 158 159 160 161 162 12 0 26 130 167 75 145 27 10 146 172 171 173 176 171 98 35 103 10 17 20 184 185 186 187 185 24 2 6 154 156 17 105 196 195 198 197 200 17 164 166 168 205 70 27 19 26 9 210 211 9 213 215 210 27 179 34 143 183 6 223 224 225 226 6 29 7 19 153 117 8 199 235 201 158 199 203 206 68 11 214 244 245 245 219 42 5 212 246 246 11 42 2 15 10 76 152 240 96 96 193 131 4 39 36 40 160 0 95 173 91 21 34 74 156 72 177 66 128 3 152 130 169 35 118 225 219 5 7 29 67 26 8 73 12 158 137 2 252 254 82 250 91 49 47 165 61 124 41 244 185 172 183 82 133 5 99 56 211 224 220 208 226 151 206 100 198 44 252 139 70 160 66 209 163 72 141 10 40 160 205 81 7 8 16 141 82 36 0 65 34 85 139 190 128 165 59 22 160 171 132 0 95 187 138 133 98 204 100 137 13 17 114 166 253 25 65 232 138 155 108 215 13 19 208 98 3 80 182 23 220 218 140 32 192 154 134 7 211 0 91 171 192 147 197 134 10 244 254 98 19 144 247 31 224 10 2 8 62 152 124 112 50 4 109 13 157 218 162 96 180 42 213 171 82 39 94 60 167 241 152 132 145 161 134 121 130 82 178 212 137 195 129 99 83 99 172 55 197 130 11 125 101 63 160 70 184 39 98 108 126 31 8 104 203 194 194 133 104 126 147 75 235 205 66 0 98 197 212 20 79 32 158 34 178 6 2 0 17 82 38 120 185 128 0 102 220 158 70 157 106 21 194 213 0 24 38 104 221 180 49 130 129 0 30 61 141 68 125 129 108 26 179 36 96 3 175 54 188 54 138 155 125 237 83 143 6 204 173 160 223 95 8 250 254 69 91 113 124 85 35 205 131 187 97 87 215 115 14 2 38 205 130 213 61 22 89 2 5 113 168 144 101 75 101 70 75 7 155 117 246 153 103 230 85 213 217 104 232 176 199 213 124 105 192 56 146 125 17 96 224 154 9 176 41 150 24 96 19 52 246 150 1 10 61 232 32 135 5 170 0 155 133 130 205 70 157 77 199 65 39 152 95 4 20 102 224 111 58 10 57 157 127 37 88 71 128 100 148 109 151 0 97 12 57 36 30 103 83 169 24 17 104 232 169 87 90 140 172 117 132 154 123 105 72 32 65 107 224 229 71 229 52 209 37 208 31 11 183 125 151 228 110 187 125 41 229 63 4 104 0 221 144 24 238 21 160 114 129 21 89 93 161 22 94 51 77 162 39 0 244 101 100 29 38 196 225 3 221 125 167 25 68 39 94 117 226 153 16 92 244 128 4 107 186 7 223 72 112 122 244 13 141 54 214 57 194 129 127 78 234 163 162 21 38 39 232 132 145 210 99 33 165 255 53 152 39 160 187 26 70 97 98 129 93 57 212 117 4 109 186 233 135 221 137 24 158 121 100 254 130 86 212 68 104 250 210 162 48 159 156 38 210 39 168 193 122 227 89 207 245 170 36 150 38 24 23 96 164 209 73 104 44 54 9 234 185 100 10 198 69 19 40 112 142 162 32 64 161 186 70 10 108 150 26 38 116 144 135 156 106 227 233 136 155 21 133 34 169 162 70 100 234 182 234 12 99 64 155 243 193 217 209 19 116 190 246 91 174 23 222 106 219 113 186 66 88 236 10 251 138 140 236 191 233 54 200 241 99 131 166 144 99 160 16 106 176 103 117 68 53 251 225 64 155 66 18 166 83 80 85 171 34 104 157 73 244 112 170 19 199 71 146 1 238 137 43 171 8 57 114 40 228 133 243 6 251 93 200 129 230 171 49 178 34 43 251 22 95 209 221 187 92 203 250 66 26 92 108 61 162 59 130 165 144 221 108 205 100 10 129 41 237 7 15 145 25 52 169 229 89 132 17 196 198 188 135 26 210 123 175 230 128 49 177 94 141 77 146 40 151 0 224 224 137 185 59 229 144 129 117 108 182 35 184 197 54 246 200 70 82 89 171 204 81 159 21 161 192 8 121 168 243 219 254 143 16 192 153 181 63 7 77 85 154 120 119 11 18 73 49 250 157 49 142 229 238 115 110 113 145 55 62 164 213 38 148 188 99 98 51 227 250 52 160 215 129 93 41 191 146 82 83 246 178 216 177 205 161 135 28 118 90 103 220 117 131 102 166 195 119 151 150 86 209 224 186 7 163 210 130 39 152 96 225 36 244 169 163 228 215 209 245 110 204 215 128 79 75 235 121 187 147 134 240 56 30 19 35 59 143 127 128 54 1 248 27 133 127 82 152 137 217 115 103 102 250 140 137 170 50 180 173 160 198 43 114 2 139 2 19 248 183 52 4 14 71 28 97 95 49 234 199 13 213 180 79 126 230 51 144 59 88 53 63 98 80 240 3 45 209 209 189 214 6 19 20 160 4 73 41 209 64 77 94 19 16 129 185 144 115 76 17 83 137 206 100 186 233 25 69 2 7 248 133 245 98 100 0 7 244 240 27 62 252 161 71 134 129 159 17 160 132 124 79 178 198 10 81 16 194 36 13 40 32 45 208 71 175 146 184 155 37 198 35 119 200 121 218 144 30 164 1 208 61 69 116 244 9 154 69 24 61 193 0 109 165 202 125 22 108 7 224 198 117 197 54 242 64 0 174 112 197 43 20 192 10 58 174 130 21 50 188 5 47 246 168 139 234 109 69 141 236 96 71 17 221 72 72 27 36 2 17 136 92 4 34 8 193 179 72 212 241 142 115 132 133 29 21 144 145 63 6 82 141 197 120 96 33 55 57 134 51 164 33 14 109 96 67 27 222 128 170 58 220 129 15 168 68 165 31 150 198 201 86 22 193 2 114 170 130 20 102 25 75 43 64 32 11 30 104 0 24 182 208 0 4 236 50 151 30 40 161 43 135 73 204 98 26 243 152 200 76 166 50 151 201 204 102 58 115 147 33 0 0 33 249 4 9 6 0 29 0 44 0 0 0 0 220 0 33 0 132 84 86 84 172 170 172 212 214 212 196 194 196 140 138 140 236 234 236 180 182 180 108 110 108 228 226 228 204 206 204 164 162 164 244 246 244 100 98 100 180 178 180 220 222 220 204 202 204 188 190 188 172 174 172 220 218 220 196 198 196 148 150 148 236 238 236 188 186 188 124 126 124 228 230 228 212 210 212 164 166 164 252 250 252 108 106 108 255 255 255 0 0 0 0 0 0 5 254 96 39 142 100 105 158 104 170 174 108 235 190 112 44 207 116 109 223 120 174 239 124 239 255 192 160 112 72 44 26 143 200 164 114 201 236 40 56 208 168 116 74 141 86 58 139 134 65 219 224 110 191 92 175 55 211 44 155 123 20 6 97 205 110 187 223 23 0 6 27 128 12 38 147 187 62 207 231 239 7 17 15 103 131 77 27 11 135 136 137 138 137 37 20 7 16 144 6 145 16 146 148 147 150 146 26 0 5 116 25 14 14 8 159 161 162 164 160 164 8 6 130 132 171 72 14 1 175 176 177 178 176 13 141 7 3 10 185 186 187 188 187 6 154 156 11 26 158 161 163 197 166 200 163 159 22 170 172 206 67 174 9 25 210 212 211 212 215 148 182 184 26 6 17 221 223 222 225 224 10 17 192 116 9 202 199 160 18 199 237 14 169 207 40 27 24 244 245 246 245 87 44 21 5 247 253 24 27 44 230 249 187 151 15 5 2 13 8 36 8 80 200 112 161 67 133 8 6 24 208 70 14 130 5 11 22 45 97 220 88 73 193 175 77 231 76 9 152 70 178 90 53 9 166 254 152 157 16 56 16 95 139 125 45 235 1 92 177 96 128 29 155 3 112 234 20 208 66 2 198 156 118 130 2 29 176 128 69 77 161 58 111 66 224 153 194 149 131 105 15 18 72 157 74 53 129 132 9 181 72 56 194 21 225 162 5 73 27 191 102 180 104 64 65 3 115 11 2 120 2 53 225 162 1 183 95 225 26 64 153 16 158 137 163 67 113 42 149 208 66 128 80 165 67 33 20 165 57 64 2 189 2 8 48 32 174 247 128 233 10 1 15 234 45 230 167 88 130 224 128 16 36 80 166 172 56 113 99 21 8 2 60 181 42 161 180 105 211 2 172 98 165 216 53 99 88 72 110 51 154 69 59 204 212 3 11 25 114 103 24 57 50 119 2 11 40 65 217 45 177 32 179 98 12 137 249 45 254 204 66 66 228 227 208 17 75 32 106 20 130 131 205 135 143 51 95 225 188 115 244 196 14 168 19 54 60 25 185 242 9 124 83 72 16 61 178 244 66 134 13 51 76 159 168 245 22 185 216 248 197 90 252 234 17 173 218 117 19 44 37 0 111 187 237 6 25 112 162 12 254 71 66 77 134 65 103 79 1 219 169 0 217 97 8 32 182 153 101 131 169 192 224 113 202 117 86 0 122 125 69 214 97 121 24 86 231 64 116 209 129 216 148 104 211 156 38 128 3 239 41 244 64 120 89 141 176 213 125 251 113 228 154 126 228 208 38 31 91 3 228 214 27 129 169 89 32 192 40 10 142 80 220 117 30 90 72 79 132 41 76 152 92 98 208 77 151 97 10 75 78 70 229 97 19 56 38 225 115 139 113 136 65 120 87 202 99 1 2 83 122 248 164 151 38 56 197 27 140 14 184 8 163 106 244 217 104 95 87 23 105 148 227 142 253 129 148 22 58 159 60 0 65 129 3 18 58 13 130 194 53 179 96 97 20 102 199 15 148 40 92 85 64 121 29 150 56 30 138 202 33 0 233 9 146 38 231 96 1 150 106 88 88 121 146 105 202 102 9 78 181 136 26 156 238 205 40 17 107 98 133 21 43 88 252 157 229 103 0 9 152 146 135 144 134 142 148 192 92 235 88 48 193 9 197 145 247 169 103 167 158 0 153 167 245 36 23 42 150 140 98 87 33 178 33 254 58 200 97 40 226 105 104 220 136 222 109 58 66 104 79 201 247 226 105 10 205 121 85 141 34 220 216 154 87 150 236 40 155 173 193 252 199 214 160 68 18 250 91 112 168 40 170 100 180 158 78 166 226 99 34 30 230 36 6 86 154 56 48 118 222 150 32 105 118 200 29 247 172 60 214 53 170 102 194 29 164 106 21 140 229 142 187 144 171 117 166 123 103 108 96 237 7 150 36 101 193 139 69 109 9 9 218 107 129 135 210 245 142 190 34 44 201 240 192 20 143 176 112 152 217 61 76 44 163 215 118 155 172 9 19 58 153 41 168 217 66 171 153 163 84 126 152 94 164 236 237 86 90 156 238 197 153 218 185 176 194 182 231 70 86 247 120 43 58 40 237 202 91 189 191 29 137 146 74 119 141 218 104 135 53 139 48 161 163 222 145 105 148 217 106 106 247 179 194 19 132 169 229 152 151 93 74 169 220 42 88 12 245 139 227 186 167 26 186 29 168 27 43 70 35 147 181 95 159 241 230 26 138 202 245 242 118 27 190 73 198 188 45 195 92 46 253 165 152 106 234 124 215 182 254 91 134 153 118 7 107 219 237 108 209 40 20 251 29 116 20 187 41 46 212 81 43 52 56 172 248 141 21 150 36 102 41 112 235 90 8 4 56 36 175 190 26 57 10 217 196 241 60 116 103 163 47 44 113 101 168 239 108 236 208 21 118 217 83 221 152 83 230 64 222 42 108 0 1 154 40 30 247 239 9 174 32 160 106 198 127 79 189 90 125 92 97 45 43 187 27 105 29 12 202 14 64 254 181 189 136 230 75 108 102 148 49 171 216 247 81 6 44 52 61 158 35 142 29 126 50 64 72 224 100 110 36 16 128 94 6 168 23 155 148 105 103 22 104 224 79 34 152 153 190 177 168 42 24 204 0 199 104 231 149 144 37 142 63 31 137 23 239 6 208 65 184 196 229 43 46 171 28 22 108 242 151 22 106 46 74 6 36 32 9 245 242 64 19 8 36 76 21 178 7 2 10 162 130 10 52 12 103 15 154 73 246 116 184 60 12 240 176 77 162 105 136 123 150 232 144 136 116 172 112 31 107 151 226 108 103 145 217 108 109 20 190 242 77 73 74 98 10 251 217 176 81 211 250 187 225 14 95 66 170 45 153 71 136 241 16 130 43 116 83 13 146 184 81 26 16 32 220 141 2 160 5 3 108 161 142 96 240 130 251 66 162 142 79 248 177 20 163 24 219 176 210 72 72 30 184 34 0 26 144 69 34 17 25 139 68 62 241 70 189 136 36 47 66 216 137 117 116 177 139 198 56 133 4 84 88 200 78 202 192 16 139 8 165 34 180 33 22 59 82 162 148 165 36 89 38 252 84 155 100 88 18 144 150 244 162 39 103 201 132 52 188 225 150 184 140 67 188 132 149 147 94 230 196 15 122 248 165 30 26 0 51 90 26 147 8 79 168 2 7 14 16 5 102 46 19 10 206 132 66 48 196 240 5 48 88 147 154 13 32 195 49 183 201 205 110 122 243 155 224 12 167 56 199 73 206 114 154 51 7 33 0 0 33 249 4 9 6 0 31 0 44 0 0 0 0 220 0 33 0 132 84 86 84 172 174 172 220 218 220 140 138 140 196 198 196 236 238 236 188 186 188 156 158 156 108 110 108 228 230 228 212 210 212 252 250 252 164 166 164 100 98 100 180 182 180 228 226 228 204 206 204 196 194 196 180 178 180 220 222 220 148 150 148 204 202 204 244 246 244 188 190 188 164 162 164 124 126 124 236 234 236 212 214 212 252 254 252 172 170 172 108 106 108 255 255 255 5 254 224 39 142 100 105 158 104 170 174 108 235 190 112 44 207 116 109 223 120 174 239 124 239 255 192 160 112 72 44 26 143 200 164 114 201 252 40 36 14 168 116 26 173 74 163 82 203 167 224 233 122 191 224 176 23 211 44 155 123 149 0 33 178 38 180 219 236 248 59 114 233 104 53 128 204 96 207 239 251 255 13 20 103 131 77 28 11 11 22 135 137 136 138 141 140 37 21 14 15 27 148 10 149 148 152 153 27 150 2 10 118 31 9 0 24 23 164 165 166 167 168 8 130 132 172 72 5 150 155 151 177 179 176 2 37 4 6 19 7 20 188 189 190 191 189 17 16 159 120 12 116 199 23 200 202 201 204 17 170 173 208 69 5 27 26 9 213 215 9 214 217 213 214 19 182 36 145 15 7 29 6 229 230 231 232 6 20 17 158 119 162 203 200 205 242 116 207 209 39 11 217 249 250 250 5 45 5 220 251 246 45 96 129 47 96 192 126 41 94 21 72 48 225 65 195 135 14 35 78 40 240 224 219 8 92 186 2 84 216 200 177 163 199 10 235 32 4 208 18 202 24 51 3 23 254 80 170 68 233 32 37 202 99 245 74 20 52 200 207 31 64 154 9 6 174 176 112 172 103 178 158 27 90 8 120 9 239 152 150 157 202 124 70 160 19 52 225 134 2 2 216 84 32 48 213 77 85 170 26 188 65 146 116 64 194 84 8 95 195 18 0 59 22 36 129 118 31 240 96 56 230 32 128 219 183 110 37 4 144 43 129 20 189 85 50 127 234 85 218 116 133 128 100 6 148 34 59 170 130 167 128 109 15 172 37 206 86 161 175 138 13 21 242 105 72 204 77 195 95 194 41 22 92 16 80 89 114 226 198 42 20 42 128 240 160 116 195 210 168 5 16 200 106 81 68 36 93 29 56 150 237 72 22 44 72 97 196 222 145 138 194 172 119 41 3 1 154 197 36 97 88 177 182 201 214 8 180 78 1 121 155 115 197 81 49 163 176 112 97 66 231 227 9 64 179 16 16 25 121 229 196 19 34 72 63 81 220 123 130 7 215 148 135 22 0 181 66 68 212 15 19 168 158 236 248 67 184 174 84 203 142 221 47 123 227 58 5 12 184 51 202 82 188 145 162 146 41 192 9 254 135 23 113 155 33 38 25 99 245 161 208 156 98 147 85 118 25 11 229 97 87 161 122 44 52 135 141 121 23 238 84 157 54 216 37 183 92 9 26 40 240 10 105 166 49 116 94 105 243 105 5 142 3 186 120 245 145 108 96 145 21 210 72 105 1 192 0 51 188 161 148 146 75 46 213 5 211 130 35 104 118 216 117 232 61 160 157 95 171 45 246 160 124 226 97 88 157 119 82 38 23 225 9 19 34 135 93 120 227 153 176 128 1 165 25 87 33 132 161 61 197 157 67 47 182 56 193 4 81 214 7 65 46 24 196 182 31 4 119 110 148 39 5 103 125 18 202 90 201 72 80 87 74 17 8 89 104 74 193 49 51 220 8 197 153 89 25 135 43 120 104 205 135 242 93 16 102 9 25 106 232 228 150 38 204 71 25 137 214 132 88 88 4 156 125 234 217 147 39 136 70 218 121 19 184 152 218 106 50 142 240 218 1 26 221 72 149 109 28 133 148 27 160 17 68 33 228 175 43 5 119 36 121 164 98 103 42 170 41 168 70 34 114 148 137 154 66 166 213 52 153 29 167 37 254 72 250 224 100 96 90 185 164 166 211 174 215 222 123 173 74 4 39 125 91 137 35 65 126 120 166 171 231 87 84 253 23 96 143 128 94 80 224 129 8 14 186 212 162 34 80 199 217 181 148 33 43 97 119 231 29 7 94 149 34 90 135 222 115 213 248 123 194 124 207 125 234 44 10 154 181 106 28 133 221 38 164 64 138 44 134 11 159 124 176 46 119 95 173 97 233 137 107 174 194 240 168 214 79 130 34 120 168 74 194 38 131 239 7 74 10 124 205 103 212 146 192 157 115 94 86 243 48 177 135 9 108 156 194 38 120 120 240 204 150 17 60 234 190 62 155 24 154 2 22 140 86 102 124 175 78 182 28 46 2 116 21 50 85 56 242 247 159 159 62 210 33 175 145 7 190 84 78 0 129 185 140 100 190 197 78 252 232 137 92 118 183 216 204 12 25 253 44 169 223 117 6 116 9 158 58 136 220 4 150 98 88 172 121 216 220 189 133 138 27 144 166 49 67 108 198 232 49 87 32 235 167 46 142 186 10 248 83 144 118 173 132 168 130 228 109 214 153 121 130 143 208 37 168 254 58 247 45 226 146 82 122 217 185 8 93 190 221 172 220 211 53 248 29 137 130 79 243 109 139 108 154 22 231 86 53 98 141 53 174 121 222 182 193 174 199 164 236 146 144 6 26 96 239 5 47 199 140 37 236 53 143 192 176 153 219 68 231 247 182 68 163 71 64 243 34 60 15 16 55 124 95 74 130 102 101 94 87 13 164 169 170 232 116 184 167 37 222 113 185 180 114 100 91 239 236 70 14 74 215 201 80 254 219 202 45 59 115 246 7 153 46 91 113 164 110 211 212 206 76 64 157 67 29 195 80 201 192 222 7 54 16 143 66 45 195 123 140 114 96 51 196 70 7 182 141 224 21 77 155 74 85 174 178 193 108 44 206 92 26 156 13 142 58 178 53 1 5 111 46 130 74 225 92 86 40 129 178 233 143 88 128 129 7 41 44 88 173 24 2 230 134 201 128 160 8 10 226 165 131 229 227 1 8 89 193 66 40 147 37 201 232 68 5 51 9 216 196 178 17 196 242 45 228 33 80 148 136 67 40 50 181 92 140 163 35 232 114 92 126 118 36 57 175 25 192 1 95 12 183 163 24 191 136 57 49 21 81 74 77 106 98 66 188 164 183 124 28 209 30 66 120 133 6 230 168 161 58 198 202 53 52 194 192 143 80 97 160 62 146 130 79 104 41 137 12 189 214 155 101 188 12 142 136 180 193 52 20 192 72 75 56 82 22 143 252 224 46 128 65 73 95 176 227 93 106 25 228 94 224 113 200 68 122 50 6 134 96 196 34 70 233 136 71 204 104 2 155 112 164 42 99 241 72 5 116 66 0 34 49 225 60 102 57 203 78 126 242 150 69 72 195 28 220 192 6 56 248 114 41 4 168 131 59 244 240 135 98 22 51 16 184 76 166 18 158 96 133 102 10 202 153 86 128 194 29 196 64 205 106 146 65 153 216 204 166 54 183 201 205 110 122 243 155 224 12 167 56 199 153 131 16 0 0 33 249 4 9 6 0 29 0 44 0 0 0 0 220 0 33 0 132 84 86 84 172 170 172 212 214 212 196 194 196 140 138 140 236 234 236 180 182 180 108 110 108 228 226 228 204 206 204 164 162 164 244 246 244 100 98 100 180 178 180 220 222 220 204 202 204 188 190 188 172 174 172 220 218 220 196 198 196 148 150 148 236 238 236 188 186 188 124 126 124 228 230 228 212 210 212 164 166 164 252 250 252 108 106 108 255 255 255 0 0 0 0 0 0 5 254 96 39 142 100 105 158 104 170 174 108 235 190 112 44 207 116 109 223 120 174 239 124 239 255 192 160 112 72 44 26 143 200 164 114 201 228 85 56 208 168 116 74 141 42 68 9 131 161 177 221 114 191 93 176 120 209 44 155 121 5 192 133 192 110 187 223 112 6 69 244 104 12 38 247 59 126 159 231 239 33 1 100 103 131 76 11 134 135 136 137 136 27 36 24 0 26 16 16 6 145 147 146 148 150 152 147 7 115 29 15 6 14 14 8 160 162 161 163 160 165 165 8 9 129 132 173 73 13 1 177 178 179 177 26 180 14 36 105 10 6 10 189 190 191 192 190 144 155 116 6 164 199 166 169 168 162 25 172 174 207 68 6 22 9 25 9 212 214 213 212 213 219 26 184 35 105 26 13 10 17 6 228 230 229 232 231 26 26 3 196 157 198 202 162 199 18 163 18 199 171 130 64 27 24 252 253 254 253 21 90 84 40 240 175 32 6 70 43 246 25 252 23 144 197 192 133 254 16 162 48 48 193 129 4 1 23 51 98 220 40 129 94 0 111 34 116 241 154 100 1 66 201 146 149 254 44 164 140 160 0 130 59 79 164 36 108 187 182 109 166 0 4 244 154 229 35 81 1 98 68 22 11 6 64 24 32 148 232 208 162 3 4 180 144 80 210 104 209 163 67 119 162 8 58 20 170 83 161 74 89 72 168 122 213 170 212 18 13 38 72 176 70 182 236 3 178 25 28 124 204 5 64 129 56 11 112 73 166 44 105 18 110 4 118 47 63 137 98 42 77 37 92 191 126 43 50 211 240 181 195 86 164 86 139 22 46 17 84 2 191 2 8 48 64 238 247 32 235 10 1 15 250 77 38 40 121 235 98 18 27 32 72 224 204 89 114 228 202 75 39 76 54 45 153 159 103 21 6 6 56 120 208 177 182 237 142 25 210 174 253 246 72 92 37 147 145 254 146 84 9 129 165 75 78 15 44 148 146 96 64 155 128 220 25 158 231 134 240 160 148 206 19 152 91 179 230 252 122 197 2 8 14 72 63 110 141 90 107 230 205 143 35 59 24 240 121 68 227 237 24 16 16 44 32 182 69 134 243 172 199 75 96 175 34 236 88 140 181 1 40 128 69 212 168 5 82 7 34 181 254 244 215 130 150 192 21 28 75 237 32 7 143 69 211 60 103 161 116 2 8 112 199 41 215 153 144 157 124 145 105 87 192 126 237 137 240 222 124 173 65 70 159 4 45 100 135 34 122 221 169 240 157 3 34 138 88 31 11 217 193 199 29 4 237 197 54 27 71 1 90 36 157 129 108 237 178 11 113 114 1 23 151 93 195 72 24 74 71 205 69 39 165 133 211 85 55 88 97 57 166 152 158 3 60 2 5 222 102 33 62 54 129 101 42 228 184 26 138 235 149 216 193 6 22 32 16 25 152 156 149 119 25 126 218 181 150 102 127 98 37 32 160 3 3 218 166 39 145 188 185 165 192 73 74 214 69 104 73 16 190 164 220 147 211 76 233 168 0 16 76 128 147 3 29 150 224 98 122 218 145 8 212 0 142 137 55 31 2 114 170 32 129 106 111 214 57 98 151 222 113 138 158 102 160 146 153 130 153 165 78 22 227 9 254 37 144 81 144 27 229 6 104 72 189 237 98 40 113 40 213 53 73 0 120 73 56 41 115 212 80 233 232 134 87 158 48 170 138 227 181 54 235 84 156 254 214 8 34 6 161 190 74 231 120 144 221 233 157 104 90 126 138 173 171 40 60 27 237 102 154 166 80 235 158 182 17 120 211 110 188 26 249 87 131 14 214 107 82 162 78 238 213 40 134 202 82 55 10 62 216 101 102 26 105 242 77 123 194 140 208 214 152 109 185 170 69 91 170 193 38 132 70 99 126 208 46 28 48 124 153 162 58 145 108 180 9 120 17 159 29 253 9 47 130 109 249 134 137 131 210 72 178 160 113 121 225 132 83 148 84 198 28 233 164 149 146 224 98 152 97 122 43 99 181 41 190 121 26 185 23 67 251 233 136 252 165 58 26 183 33 174 216 162 192 4 219 89 52 10 235 222 22 164 174 35 131 243 214 175 115 1 55 201 93 17 22 19 83 133 83 198 204 44 165 206 88 202 180 100 243 65 6 49 99 170 166 39 158 197 38 60 155 180 207 24 112 169 230 137 177 146 7 180 135 248 9 93 176 198 39 248 104 235 70 124 22 30 242 128 85 183 53 146 214 193 45 184 146 2 93 191 35 143 0 251 74 233 40 117 244 168 82 182 205 125 211 77 244 221 254 224 174 150 31 220 102 99 186 93 186 50 134 142 105 156 123 151 96 110 157 210 2 110 130 143 149 117 100 209 199 31 83 131 64 226 130 198 213 248 36 191 253 197 114 190 29 85 30 157 204 146 130 82 243 8 152 133 185 234 218 36 156 216 179 138 99 166 38 94 180 118 179 16 154 155 53 182 118 227 156 58 62 134 58 173 121 118 68 248 109 84 31 104 181 175 117 21 202 160 5 92 43 154 57 229 201 62 26 29 179 50 17 230 108 195 215 19 164 115 10 223 25 64 83 134 66 151 162 180 206 102 79 33 224 83 132 114 55 1 46 176 41 22 16 10 139 112 196 149 72 56 48 18 145 232 17 199 206 82 150 14 22 136 119 188 104 223 112 24 68 18 124 121 13 20 124 89 146 112 2 67 138 229 137 0 82 69 137 96 85 8 40 187 19 40 100 53 242 241 7 2 26 178 130 158 208 173 32 5 144 72 10 20 194 143 185 249 131 135 42 24 8 206 88 5 25 33 206 78 54 183 242 24 71 222 165 62 197 249 234 36 246 34 73 93 134 119 66 81 208 228 26 95 140 195 142 117 54 55 2 37 198 167 136 240 113 34 52 214 56 59 8 64 71 27 52 169 9 53 186 81 36 223 128 33 12 90 192 35 177 34 7 147 83 144 66 25 168 120 82 40 0 198 198 66 242 0 22 196 170 5 45 100 161 129 8 4 32 2 85 12 71 48 38 25 140 227 20 35 21 153 59 197 50 148 33 19 50 26 242 147 52 80 132 40 21 33 68 71 64 2 73 192 75 165 36 84 89 18 69 9 82 30 161 128 229 31 77 145 1 253 129 242 150 76 72 195 26 224 192 75 94 202 129 14 17 32 138 48 135 73 204 62 16 101 2 128 80 19 46 151 217 131 2 84 1 10 7 128 166 52 167 16 205 43 116 32 11 92 200 99 30 239 136 199 6 124 161 1 202 100 166 56 199 73 206 114 154 243 156 232 76 167 58 215 201 206 91 134 0 0 33 249 4 9 6 0 31 0 44 0 0 0 0 220 0 33 0 132 84 86 84 172 174 172 220 218 220 140 138 140 196 198 196 236 238 236 188 186 188 156 158 156 108 110 108 228 230 228 212 210 212 252 250 252 164 166 164 100 98 100 180 182 180 228 226 228 204 206 204 196 194 196 180 178 180 220 222 220 148 150 148 204 202 204 244 246 244 188 190 188 164 162 164 124 126 124 236 234 236 212 214 212 252 254 252 172 170 172 108 106 108 255 255 255 5 254 224 39 142 100 105 158 104 170 174 108 235 190 112 44 207 116 109 223 120 174 239 124 239 255 192 160 112 72 44 26 143 200 164 114 201 228 89 28 18 9 84 74 133 90 163 87 171 66 132 241 120 191 224 176 248 91 104 154 207 206 206 133 16 33 176 223 237 184 91 222 14 84 68 148 198 96 207 239 251 255 25 0 9 104 132 77 11 11 22 135 137 136 138 141 140 28 36 22 29 10 2 27 150 151 152 153 152 15 14 119 31 20 8 23 162 163 164 165 166 12 0 26 133 171 73 149 10 27 175 176 150 177 180 176 101 35 146 16 17 20 188 189 190 191 189 7 156 158 160 17 23 198 200 199 202 201 204 168 170 172 208 68 27 19 26 9 213 214 9 216 218 213 27 183 34 185 4 20 6 6 23 227 230 231 231 29 7 19 6 196 8 204 203 241 240 23 206 66 11 217 248 249 249 222 42 5 215 250 250 22 176 184 7 16 32 191 20 254 10 6 84 33 224 65 129 9 19 30 64 148 72 49 226 132 4 5 186 69 154 180 171 130 199 143 32 67 86 8 128 65 64 39 60 239 254 148 149 35 199 242 130 131 114 48 143 69 168 103 162 128 194 133 43 44 32 219 41 83 230 134 22 2 200 69 128 55 244 152 5 22 58 151 241 44 250 147 133 0 165 61 139 70 56 154 66 0 53 2 21 176 106 213 154 149 128 128 2 10 248 229 234 40 50 43 4 179 89 71 10 59 249 41 165 177 0 112 227 6 144 48 55 174 3 99 244 82 157 216 32 117 41 50 170 42 116 10 200 166 225 129 53 195 217 42 52 93 177 161 2 190 194 219 158 2 78 177 224 130 128 107 255 32 43 6 74 0 242 97 109 146 25 26 174 208 240 1 69 211 20 33 132 253 186 81 65 71 173 16 176 126 36 112 246 35 73 118 238 144 25 144 32 212 148 40 7 119 143 209 44 209 248 177 225 127 161 115 94 160 70 184 121 181 205 78 29 67 198 108 120 194 84 164 17 6 79 79 240 160 154 6 175 45 20 72 255 220 92 192 245 170 87 173 154 230 30 17 53 132 110 97 55 234 162 224 177 182 89 218 30 105 211 14 176 142 109 49 101 1 180 20 83 57 17 72 129 12 6 122 153 254 80 220 118 216 104 96 222 100 40 8 214 96 131 221 129 199 194 130 20 98 147 92 96 203 109 179 141 133 140 57 246 153 119 217 108 120 66 67 9 16 96 81 2 23 73 196 226 3 239 21 112 89 107 175 161 133 22 126 182 97 128 27 74 186 5 24 83 4 227 0 185 91 112 17 32 248 12 113 34 82 7 153 137 17 46 55 29 98 132 17 176 152 10 197 145 71 162 117 16 158 176 128 1 235 61 121 13 116 33 122 216 28 150 12 81 67 26 106 168 177 151 128 106 96 137 213 193 124 245 217 56 91 108 103 241 247 128 4 185 41 35 133 40 2 146 115 129 129 162 12 71 194 130 199 33 86 205 131 216 105 231 220 97 96 50 212 217 113 218 88 195 228 9 130 49 72 216 3 141 166 80 229 118 75 94 144 37 9 40 122 117 145 69 46 154 6 193 87 241 225 194 17 125 176 221 23 18 86 18 244 151 39 144 1 10 37 160 40 123 14 101 228 94 21 64 234 225 164 38 72 136 25 119 154 77 169 233 120 143 29 70 166 114 138 146 88 44 103 195 142 136 40 122 223 254 181 199 29 119 167 85 176 154 155 112 86 112 22 126 224 210 233 145 157 254 165 132 43 75 126 2 9 19 160 69 38 136 228 54 133 58 120 30 135 212 116 215 28 54 153 162 32 64 103 247 66 10 108 9 149 93 100 165 189 249 242 58 226 189 255 138 208 208 119 13 89 212 162 139 49 166 250 205 170 173 226 136 99 90 228 230 102 204 144 164 140 35 10 144 128 230 117 228 160 73 250 90 162 167 137 58 87 104 2 5 43 40 157 189 222 117 55 109 96 217 13 235 25 195 45 108 122 41 54 203 234 123 85 123 134 149 106 106 55 26 169 218 173 141 22 199 73 146 73 179 238 230 241 143 30 179 187 171 203 19 78 56 115 10 149 94 58 108 203 37 236 123 243 202 19 160 156 83 118 7 147 200 53 201 20 198 236 160 216 62 51 60 42 106 111 179 57 163 209 225 32 93 91 184 88 101 204 227 49 6 248 248 241 173 82 187 139 118 178 133 29 202 54 214 150 145 71 222 217 35 108 106 232 113 87 55 169 232 193 44 27 171 47 191 145 106 120 184 9 11 171 136 230 195 254 18 157 218 38 141 244 229 119 183 125 32 221 214 206 222 184 190 100 206 40 44 5 62 114 227 227 125 45 239 167 37 8 155 118 133 150 159 136 121 102 217 132 141 59 9 149 117 121 111 53 32 82 249 114 213 183 151 201 176 208 46 94 196 102 209 19 195 105 241 221 247 213 41 43 143 67 57 77 138 186 234 134 44 40 237 59 255 147 64 194 184 240 189 76 186 199 244 174 96 50 124 195 51 60 46 64 50 99 171 49 2 228 28 79 252 164 204 111 213 119 91 113 3 87 176 2 31 55 185 134 62 223 58 93 156 114 180 163 182 168 235 2 112 137 2 93 38 56 23 186 220 197 24 83 35 142 74 152 129 151 121 81 102 103 196 202 135 67 90 96 147 149 1 68 3 2 89 1 65 178 241 184 125 144 208 51 215 210 218 3 82 168 47 135 72 164 61 14 187 161 105 100 52 178 177 176 74 129 105 209 207 184 132 129 39 238 241 205 0 14 64 162 57 146 152 68 143 233 74 112 35 240 135 9 131 6 25 26 70 227 138 40 152 198 132 156 181 69 137 125 64 18 7 228 158 83 199 124 115 1 117 76 160 92 240 155 7 81 2 5 69 44 186 17 7 149 144 133 44 94 65 71 88 212 145 91 187 0 134 30 125 177 150 89 201 227 143 204 200 224 27 7 105 3 71 44 226 144 134 92 0 36 84 69 137 57 218 81 0 10 168 99 36 97 1 201 6 254 103 141 152 60 134 32 9 201 201 36 72 194 0 112 96 67 5 134 18 202 54 140 114 40 17 176 3 30 244 240 135 86 182 50 16 179 235 164 44 137 96 129 42 80 1 11 182 156 66 21 128 179 133 15 96 160 1 99 240 0 48 131 25 134 131 204 242 152 200 76 166 50 151 201 204 102 58 243 153 208 140 230 50 67 0 0 33 249 4 9 6 0 29 0 44 0 0 0 0 220 0 33 0 132 84 86 84 172 170 172 212 214 212 196 194 196 140 138 140 236 234 236 180 182 180 108 110 108 204 206 204 156 158 156 228 230 228 244 246 244 100 98 100 180 178 180 220 222 220 204 202 204 188 190 188 164 166 164 172 174 172 220 218 220 196 198 196 148 150 148 236 238 236 188 186 188 124 126 124 212 210 212 164 162 164 252 250 252 108 106 108 255 255 255 0 0 0 0 0 0 5 254 96 39 142 100 105 158 104 170 174 108 235 190 112 44 207 116 109 223 120 174 239 124 239 255 192 160 112 72 44 26 143 200 164 114 201 108 174 52 156 168 116 74 173 74 45 157 69 163 97 224 122 187 221 175 56 156 113 154 207 186 10 131 192 110 187 223 112 12 64 145 13 64 6 20 188 62 79 225 239 247 18 15 104 131 75 27 11 135 136 137 138 137 37 21 7 16 144 6 145 147 16 146 149 148 17 0 5 117 8 10 14 159 160 161 162 162 23 130 132 167 70 14 1 171 172 173 174 172 13 141 7 3 26 9 181 182 9 184 186 183 181 6 153 155 11 1 8 160 158 14 197 199 159 200 14 165 168 205 67 170 8 25 209 211 212 210 211 16 177 36 142 3 17 1 6 223 224 225 226 6 9 13 191 117 25 163 234 235 204 38 27 10 240 241 242 241 88 44 22 5 243 249 10 27 44 239 250 243 245 86 220 251 39 143 223 10 127 4 225 5 60 161 202 193 4 1 15 35 66 156 248 208 1 133 108 35 182 105 144 112 161 163 199 143 32 47 104 48 160 65 83 150 8 233 254 60 77 200 192 178 165 203 150 19 140 77 104 87 98 193 128 59 55 7 228 220 41 160 197 76 156 119 130 234 188 179 128 133 77 161 59 129 246 100 49 1 41 208 161 3 138 174 56 10 53 169 206 165 40 26 10 64 128 224 1 215 175 96 17 76 184 40 139 22 199 142 146 66 122 132 112 33 129 47 147 193 210 125 122 160 54 100 204 79 52 73 216 156 0 15 159 2 191 240 30 96 85 33 224 65 60 191 136 155 74 85 177 1 194 4 196 135 3 15 78 49 22 48 100 5 138 251 57 238 203 249 175 2 193 42 26 178 156 64 186 180 105 1 25 38 12 48 80 118 227 5 182 176 95 203 102 123 65 146 6 115 112 133 129 162 251 242 37 221 152 152 243 142 88 0 193 193 101 124 248 64 51 53 124 28 158 234 197 41 246 122 158 222 87 249 138 194 158 1 123 126 110 116 0 95 200 128 173 51 12 160 64 26 105 136 17 37 62 112 176 186 53 199 180 146 12 212 190 36 187 45 110 96 1 228 42 208 153 1 117 239 194 6 220 181 140 41 53 121 55 157 118 5 80 254 48 65 11 25 48 71 221 118 16 64 135 2 113 198 88 54 157 120 148 81 128 224 97 153 77 117 65 133 243 248 133 97 9 162 245 23 83 69 232 61 36 22 89 218 204 226 26 109 176 193 56 159 36 110 149 4 12 74 187 13 192 18 106 60 242 136 192 5 2 10 39 2 133 218 117 54 226 9 216 81 151 88 84 154 61 246 96 60 71 154 48 214 131 200 97 198 228 65 142 85 137 96 148 34 136 38 214 121 14 129 185 213 88 24 137 160 209 89 105 133 20 163 72 111 225 167 31 127 60 246 39 231 86 1 130 34 100 22 6 106 41 15 151 36 84 22 25 135 17 118 199 87 103 85 242 57 66 131 156 21 217 161 10 210 133 8 229 100 36 6 224 192 104 2 132 89 209 121 235 181 215 162 89 150 116 116 73 154 181 117 84 206 57 11 224 56 151 142 115 182 132 218 143 124 225 69 160 94 121 254 99 168 8 126 110 104 165 132 39 236 85 192 101 143 250 228 224 159 5 112 55 85 150 217 69 198 167 151 165 165 88 169 138 100 186 183 86 90 177 197 214 22 73 185 254 201 197 30 170 61 250 7 96 144 175 14 87 92 115 201 45 200 2 162 255 4 27 232 65 31 234 131 156 119 12 26 246 39 132 184 186 179 153 173 159 65 74 66 137 203 130 169 30 123 172 109 250 226 124 32 193 199 150 91 1 192 101 234 126 58 250 167 106 127 172 218 217 237 144 177 30 40 153 79 26 74 236 151 176 140 198 202 235 3 226 94 247 107 103 183 10 250 164 136 29 159 48 129 164 163 93 170 242 152 44 102 228 226 89 210 94 18 243 109 54 162 179 27 4 253 9 160 115 170 13 187 154 107 196 132 178 203 66 146 242 44 25 111 77 223 22 157 157 208 30 43 157 29 198 209 25 88 108 161 246 142 160 149 137 42 163 184 98 153 29 156 137 22 109 157 174 85 219 109 164 234 102 12 127 11 199 137 64 128 197 220 73 161 211 80 150 156 2 162 205 133 140 46 136 78 207 218 65 173 132 6 103 16 163 31 22 121 216 177 40 247 23 102 165 249 178 204 181 215 144 120 90 223 167 144 212 88 237 39 19 60 144 112 156 218 246 60 224 207 78 130 247 23 211 254 132 125 92 44 212 19 122 231 185 103 28 183 107 113 60 164 115 62 245 133 101 164 80 34 152 150 78 148 90 203 102 190 236 145 192 243 73 235 22 169 7 163 141 57 143 116 85 234 179 9 196 177 53 192 5 203 119 212 252 0 85 151 240 211 242 205 123 68 253 209 176 190 70 189 243 204 119 36 55 10 2 108 95 189 248 216 123 43 62 247 212 71 223 129 42 229 121 21 86 88 153 246 235 178 89 158 174 217 248 71 16 144 61 249 92 161 202 231 127 255 31 50 198 230 220 97 161 93 69 102 33 41 24 72 100 12 232 153 191 165 0 33 239 234 11 2 81 96 1 96 41 205 129 40 128 32 200 232 17 26 73 73 228 131 233 169 20 238 186 166 59 128 169 9 96 146 195 207 48 48 195 146 105 72 227 133 46 12 197 157 156 65 67 28 168 162 133 56 204 97 52 88 130 141 214 120 227 27 95 0 131 16 185 160 63 55 9 136 24 201 64 34 41 30 86 195 38 214 64 21 173 136 128 4 2 208 13 42 174 162 138 222 104 77 46 106 113 139 92 120 17 23 183 160 121 214 141 244 211 170 117 132 2 51 3 116 162 26 107 96 136 69 184 81 17 101 153 205 107 32 65 199 58 198 8 2 101 179 22 26 139 161 142 61 206 132 137 107 12 100 17 212 0 135 66 26 82 14 248 185 64 30 116 194 200 1 88 238 145 142 212 137 229 116 210 0 64 10 242 146 64 128 130 21 56 192 128 77 86 1 24 91 8 195 5 26 48 202 45 152 242 148 166 44 101 236 48 201 202 86 186 242 149 176 140 165 44 103 73 203 90 218 50 8 33 0 0 33 249 4 9 6 0 31 0 44 0 0 0 0 220 0 33 0 132 84 86 84 172 174 172 220 218 220 140 138 140 196 198 196 236 238 236 188 186 188 156 158 156 108 110 108 228 230 228 212 210 212 252 250 252 164 166 164 100 98 100 180 182 180 228 226 228 204 206 204 196 194 196 180 178 180 220 222 220 148 150 148 204 202 204 244 246 244 188 190 188 164 162 164 124 126 124 236 234 236 212 214 212 252 254 252 172 170 172 108 106 108 255 255 255 5 254 224 39 142 100 105 158 104 170 174 108 235 190 112 44 207 116 109 223 120 174 239 124 239 255 192 160 112 72 44 26 143 200 164 114 201 108 174 20 18 71 116 58 149 90 171 88 203 167 224 233 122 191 224 176 23 227 44 155 117 149 0 33 178 38 180 217 240 247 251 210 209 106 0 153 129 126 207 239 251 27 20 103 130 75 28 11 11 22 134 136 135 137 140 139 37 21 14 15 27 147 148 149 150 149 2 10 117 31 9 0 24 23 160 161 162 163 164 8 129 131 168 70 5 10 147 172 27 174 176 173 147 2 37 4 6 19 7 20 186 187 188 189 187 17 16 155 119 12 17 23 197 199 198 201 200 203 166 169 206 67 5 27 26 9 211 213 9 212 215 211 212 19 180 36 144 15 7 29 6 227 228 229 230 6 20 17 154 118 158 203 202 239 238 17 205 38 11 215 246 247 247 5 45 5 218 248 248 11 44 234 249 243 167 143 5 191 129 255 2 34 196 87 16 197 170 2 9 38 60 144 72 113 162 197 9 5 30 116 27 97 11 151 132 10 32 67 138 28 89 33 157 2 6 236 254 62 21 187 96 128 165 1 7 44 47 192 108 217 242 216 188 18 22 142 233 52 166 115 67 11 1 53 227 29 211 178 34 167 178 157 17 138 249 100 33 224 40 207 167 17 136 170 48 154 20 106 79 21 209 10 8 96 83 129 64 87 55 95 189 106 224 246 40 82 56 144 94 73 146 76 7 33 0 59 98 198 28 4 144 16 96 174 93 186 117 37 128 42 118 147 68 78 1 217 30 80 19 124 173 194 210 21 27 42 216 211 32 88 155 134 166 82 83 44 184 32 192 241 98 193 134 127 18 96 28 24 91 2 200 1 41 119 118 252 32 115 138 135 10 32 60 88 45 113 181 107 1 155 201 122 115 224 209 43 132 174 16 188 18 200 141 219 171 201 77 157 48 28 147 66 42 84 4 3 1 148 245 29 97 225 194 4 203 216 166 153 94 33 64 49 103 210 17 163 178 248 59 24 219 131 106 4 54 170 80 96 189 123 182 207 218 139 70 0 108 153 115 130 233 39 180 106 173 96 209 53 197 207 155 37 149 5 23 0 237 109 220 0 134 68 0 5 187 9 227 73 50 196 137 254 210 18 40 47 233 149 204 114 34 112 103 77 53 223 133 215 66 98 209 117 55 13 104 69 57 231 153 53 212 88 200 2 134 26 122 198 225 84 183 68 215 24 54 240 153 128 154 106 172 69 148 192 107 177 137 247 1 36 19 96 208 31 90 32 253 215 85 111 16 252 246 214 112 122 213 180 224 145 201 217 116 10 78 206 93 71 88 54 4 28 166 2 137 238 89 51 65 122 42 44 96 192 106 26 126 87 152 148 41 96 8 29 54 87 70 134 194 100 149 17 134 93 139 37 60 84 221 68 51 218 23 209 4 249 129 9 193 45 7 72 96 91 111 1 2 200 22 112 237 196 229 224 56 44 29 199 160 94 74 158 32 225 121 20 178 121 2 108 215 121 70 205 137 41 252 21 233 101 142 154 64 229 138 156 81 138 194 162 131 57 22 37 86 149 109 0 35 156 19 196 169 81 141 101 213 214 39 144 60 154 132 210 7 119 8 103 140 4 14 26 74 168 75 1 24 144 168 9 160 78 243 29 102 96 162 32 230 61 20 150 185 157 104 19 118 151 105 9 144 158 167 225 86 102 254 42 202 172 121 44 22 75 130 155 244 165 10 231 69 116 50 6 230 55 103 9 152 155 143 186 221 38 36 173 129 202 84 100 76 161 208 148 164 49 16 126 208 220 115 94 126 248 158 182 38 68 235 217 138 158 158 48 89 170 230 49 38 29 191 37 136 185 162 137 23 84 75 143 135 85 94 55 234 105 10 172 2 163 183 114 66 42 219 8 56 234 232 159 185 187 85 240 223 128 192 24 168 82 4 9 50 104 204 145 18 212 116 65 189 220 169 232 44 194 36 40 60 225 119 212 110 183 94 123 106 138 136 152 98 31 174 168 172 122 128 101 232 217 179 91 8 48 159 125 223 174 6 169 70 181 224 169 167 200 187 133 60 178 159 234 0 10 23 202 69 234 74 19 75 243 202 179 164 95 59 7 102 25 210 35 60 61 154 96 19 52 172 51 123 156 102 123 97 121 6 135 26 48 176 235 133 170 47 210 47 126 59 227 125 26 219 72 238 142 1 166 21 242 143 127 166 132 224 160 43 239 53 78 216 48 51 251 164 123 104 139 176 233 104 57 119 200 222 104 95 106 54 38 54 254 119 151 160 229 230 215 120 201 24 223 21 191 137 106 156 115 214 89 2 4 180 97 208 193 199 135 135 124 184 172 67 10 26 19 161 95 35 167 220 216 204 229 125 179 193 19 83 183 153 180 158 181 237 176 232 23 112 9 221 52 62 79 105 93 220 147 98 89 105 147 166 119 198 183 210 169 53 93 223 68 172 206 198 95 143 34 29 126 53 91 110 177 107 43 215 141 199 123 168 203 145 27 122 204 130 199 208 60 194 6 200 172 236 206 242 100 251 170 140 145 197 176 145 177 222 161 63 81 240 111 4 147 49 84 1 149 65 51 55 129 197 13 15 124 32 99 4 71 155 60 253 168 106 35 227 141 200 74 66 128 117 112 34 80 92 187 11 174 112 101 23 200 1 79 4 2 113 79 190 74 215 16 172 204 8 91 200 2 200 10 4 82 186 206 216 163 133 167 113 207 11 205 246 0 25 102 233 50 64 156 17 14 219 84 153 191 85 100 2 71 196 136 126 196 119 128 29 29 174 79 85 43 73 201 114 119 28 7 144 195 138 88 44 199 239 158 193 197 31 172 162 89 96 36 154 19 5 193 33 14 149 45 8 94 241 90 87 173 86 178 146 189 16 48 25 15 58 97 23 231 88 131 104 176 66 1 119 188 227 43 246 120 71 10 226 194 23 128 236 5 48 210 23 156 163 84 37 30 86 169 23 29 23 9 131 66 44 226 145 138 80 132 33 28 33 62 62 90 82 143 152 220 192 4 60 56 140 252 193 227 147 191 98 164 40 149 144 6 57 196 225 148 166 36 0 29 180 208 137 60 248 225 149 175 4 196 40 103 137 4 40 92 225 10 88 184 37 174 164 32 1 45 112 65 12 192 4 230 1 104 73 204 98 26 243 152 200 76 166 50 151 201 204 102 58 115 8 33 0 0 33 249 4 9 6 0 29 0 44 0 0 0 0 220 0 33 0 132 84 86 84 172 170 172 212 214 212 196 194 196 140 138 140 236 234 236 180 182 180 108 110 108 204 206 204 156 158 156 228 230 228 244 246 244 100 98 100 180 178 180 220 222 220 204 202 204 188 190 188 164 166 164 172 174 172 220 218 220 196 198 196 148 150 148 236 238 236 188 186 188 124 126 124 212 210 212 164 162 164 252 250 252 108 106 108 255 255 255 0 0 0 0 0 0 5 254 96 39 142 100 105 158 104 170 174 108 235 190 112 44 207 116 109 223 120 174 239 124 239 255 192 160 112 72 44 26 143 200 164 114 201 108 26 45 156 168 116 74 173 74 53 206 172 118 75 42 0 48 132 176 120 76 46 51 42 220 180 58 182 104 187 223 240 247 134 164 0 104 32 16 3 94 159 223 251 251 120 7 104 107 132 133 39 13 1 137 138 139 140 138 14 93 0 17 13 9 26 9 148 150 149 151 154 149 17 16 130 134 160 160 6 23 8 25 8 165 167 166 168 168 25 17 143 35 94 26 6 178 6 181 182 183 184 1 26 3 159 38 27 10 192 193 194 193 22 45 22 5 195 201 10 115 43 191 202 195 197 44 199 207 194 204 42 206 212 192 209 43 211 217 203 42 6 20 14 19 2 228 230 229 229 228 14 14 1 175 34 177 6 9 23 243 244 245 246 23 18 157 189 37 11 3 16 3 254 0 254 11 56 64 64 139 9 23 6 254 91 40 112 192 2 22 253 24 18 84 104 144 197 4 137 10 27 62 92 17 177 225 68 128 21 87 92 252 248 113 35 138 6 20 254 38 156 90 201 146 101 6 118 238 58 192 211 112 175 38 61 9 187 246 145 232 55 1 24 50 5 63 129 61 8 169 66 192 131 96 63 147 94 52 153 98 3 132 9 73 145 10 37 154 98 2 133 160 81 21 44 101 225 180 39 80 159 96 135 182 48 42 44 235 214 20 6 6 56 120 48 161 173 219 183 42 5 192 132 164 97 82 194 187 16 240 226 213 147 207 211 32 126 16 28 100 69 134 76 172 197 163 131 129 77 112 8 113 64 207 172 62 13 175 32 75 184 172 86 198 28 29 127 253 26 84 114 81 196 137 23 51 53 129 50 110 91 116 230 218 150 82 208 14 82 132 89 23 244 200 206 59 106 246 60 156 188 254 238 212 12 25 104 202 22 25 16 111 6 123 86 197 130 192 195 43 43 240 92 245 170 101 159 197 83 44 184 224 96 56 216 229 84 81 88 13 58 172 64 116 19 105 215 166 131 139 46 195 203 214 176 236 76 202 155 247 110 66 60 238 241 233 211 61 226 184 224 100 63 153 163 32 155 28 58 230 107 79 41 55 140 126 39 88 101 93 101 162 113 254 21 32 103 101 17 104 2 127 88 125 149 96 10 165 33 144 142 92 114 181 53 142 133 115 165 39 11 77 243 180 167 135 61 35 226 166 83 125 188 49 24 140 131 37 108 39 21 82 223 157 192 211 139 149 177 72 66 112 96 113 167 21 4 163 201 168 89 119 43 102 119 2 127 47 42 198 163 10 21 154 51 206 57 170 201 133 222 59 118 192 22 27 32 83 242 209 158 137 244 137 48 163 142 65 30 228 28 119 63 77 104 156 99 5 244 134 221 65 194 209 40 166 116 11 10 88 152 144 38 76 144 166 89 255 29 146 146 133 167 105 56 129 3 114 153 215 33 148 117 201 195 30 61 237 181 55 37 78 126 201 24 88 98 133 77 0 220 81 207 120 119 100 51 212 41 67 152 99 143 62 39 225 164 0 62 166 169 141 35 224 248 28 50 107 146 118 231 120 168 101 88 202 159 50 69 73 211 136 9 193 58 91 94 249 228 230 163 167 155 229 7 103 139 95 230 168 88 157 40 108 153 235 138 142 178 64 153 166 165 222 106 221 102 108 141 37 220 96 201 146 144 100 58 124 254 142 179 36 135 79 182 42 139 160 245 20 58 232 109 57 101 217 129 176 52 98 106 44 164 163 70 11 216 125 82 93 90 236 100 232 14 235 29 176 202 50 88 227 174 36 184 120 93 152 23 88 99 167 74 25 156 182 36 106 126 102 59 19 161 176 246 65 40 62 119 156 168 37 114 69 10 245 174 10 56 38 118 89 143 190 84 170 163 174 94 42 23 21 66 254 6 75 29 151 145 225 59 130 129 140 170 43 194 180 3 239 169 170 147 49 197 98 215 136 236 193 58 229 109 17 216 106 2 79 30 115 102 46 188 7 74 72 239 206 100 250 250 85 179 44 84 108 244 197 141 121 90 89 126 25 160 105 89 80 42 119 80 225 133 227 100 72 78 193 49 187 170 87 194 238 229 129 165 162 121 13 112 129 217 243 160 93 208 65 9 153 141 54 61 110 99 204 143 217 255 156 157 182 221 23 76 156 130 0 110 227 109 119 220 16 213 221 247 223 103 155 44 130 0 130 223 221 247 208 35 84 216 18 75 15 164 194 42 60 242 204 195 7 61 35 210 220 151 195 29 108 16 97 153 164 82 109 163 66 55 57 70 21 242 9 216 68 12 148 232 41 88 64 163 101 167 251 130 95 50 172 163 208 141 128 213 32 41 142 91 23 230 73 173 193 94 127 75 37 124 224 234 28 202 241 105 140 98 94 41 166 44 111 94 243 165 0 191 173 1 13 80 143 75 245 13 84 79 125 0 57 115 142 252 247 74 24 176 72 4 138 144 207 189 34 18 36 210 245 135 152 180 95 73 38 240 83 146 40 248 244 51 17 199 253 113 248 91 71 39 239 245 239 45 123 0 52 94 253 6 8 62 47 128 161 12 8 68 224 25 8 200 192 239 21 192 10 16 140 96 2 26 72 193 10 90 240 130 24 204 160 6 55 200 193 14 118 48 4 0 33 249 4 9 6 0 22 0 44 0 0 0 0 220 0 33 0 132 148 150 148 204 206 204 236 234 236 180 178 180 220 222 220 196 194 196 244 246 244 172 170 172 212 214 212 188 190 188 228 230 228 204 202 204 252 254 252 156 158 156 212 210 212 236 238 236 180 182 180 228 226 228 196 198 196 252 250 252 172 174 172 220 218 220 255 255 255 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 5 254 160 37 142 100 105 158 104 170 174 108 235 190 112 44 207 116 109 223 120 174 239 124 239 255 192 160 112 72 44 26 143 200 164 114 201 108 26 13 144 65 116 42 173 86 169 212 129 195 201 237 122 73 134 67 162 32 33 155 203 18 244 249 76 89 124 223 240 216 100 98 152 215 233 246 60 158 1 62 4 42 8 129 130 131 132 131 17 16 110 113 138 139 39 128 14 8 143 144 146 147 145 14 15 125 14 5 0 155 156 157 158 156 13 135 137 140 164 139 8 4 2 10 169 170 10 172 174 169 8 151 35 97 1 154 9 183 184 185 186 9 7 13 21 136 39 19 173 195 196 196 178 43 15 171 197 197 19 44 194 203 203 199 42 201 208 204 206 213 197 210 41 212 216 173 205 41 21 17 15 4 4 17 229 231 230 233 10 15 177 152 154 11 240 241 240 5 243 242 189 162 39 6 5 99 251 5 253 255 8 90 84 184 229 111 140 193 130 5 12 176 208 119 240 31 191 4 1 89 12 116 136 176 159 194 21 12 43 62 244 23 113 197 196 141 20 47 162 168 128 74 194 2 147 40 254 79 170 148 16 203 82 159 90 0 224 153 84 41 175 230 128 80 192 76 232 171 208 74 64 4 85 63 91 45 232 168 2 193 130 97 62 95 13 20 153 98 66 130 10 171 148 37 29 42 80 66 82 160 174 150 58 123 218 243 103 212 8 84 89 24 29 22 225 171 2 173 224 126 46 8 87 46 66 186 116 127 30 64 117 23 115 102 60 187 50 79 222 252 53 10 76 2 84 61 3 167 10 235 241 104 82 179 4 18 46 44 192 243 176 130 178 170 36 84 104 225 192 48 214 192 21 20 99 100 252 234 50 225 162 134 205 166 74 204 212 4 73 1 146 221 154 123 76 224 49 216 150 210 104 189 203 59 51 165 93 10 56 251 206 226 156 170 55 80 212 147 197 46 128 220 219 235 217 4 165 243 253 237 28 85 114 139 177 88 125 31 79 174 147 107 113 86 131 137 130 179 234 213 120 42 180 35 127 74 110 237 150 252 185 0 177 230 206 58 144 169 110 222 147 1 106 234 245 149 179 132 129 191 135 131 246 100 249 252 232 101 223 164 109 5 85 89 221 173 242 89 10 99 69 254 133 148 2 1 174 224 212 128 129 97 117 32 10 9 70 232 147 0 153 81 55 194 105 107 173 166 218 135 113 185 180 30 76 242 73 16 31 124 38 194 131 27 62 58 241 38 24 80 19 54 98 149 96 65 97 136 220 98 60 97 87 227 107 253 117 165 227 116 56 190 2 89 100 218 141 36 129 143 87 1 153 150 2 18 180 213 218 57 12 42 48 212 3 34 138 64 139 4 117 5 144 226 123 180 221 196 162 125 46 178 66 160 148 69 158 144 160 126 197 53 168 194 78 162 177 18 163 105 51 10 169 74 134 11 89 119 153 155 101 154 96 148 130 216 49 168 217 72 37 133 19 229 135 110 161 71 101 108 236 205 38 147 150 139 218 21 0 110 4 212 231 23 42 67 42 248 102 9 21 196 169 12 43 4 220 184 89 142 142 237 151 103 9 103 118 166 164 10 15 254 119 24 127 18 105 58 230 119 158 134 135 26 148 233 60 73 166 92 2 188 164 9 74 39 194 231 171 137 18 120 41 233 110 160 70 167 214 168 36 84 120 225 111 116 98 244 20 159 23 242 216 234 178 209 254 249 169 33 24 156 245 233 202 165 201 26 102 28 118 205 2 10 28 161 174 21 90 193 161 116 221 165 101 175 139 170 152 91 62 140 125 101 41 178 27 114 247 88 126 12 198 218 212 179 52 26 72 175 8 208 245 121 33 120 41 236 244 91 103 220 214 75 237 87 157 94 107 193 105 77 218 10 101 107 83 86 105 129 108 89 202 3 108 175 38 174 56 172 149 214 161 25 84 194 0 251 119 213 97 225 22 204 91 119 129 145 252 240 140 202 24 71 48 10 169 198 92 156 203 153 46 24 221 204 152 170 21 206 91 228 153 99 168 197 97 180 167 110 138 181 245 234 177 110 86 186 88 220 133 172 122 164 169 206 13 7 201 156 80 255 90 80 170 0 210 169 89 240 179 196 249 232 242 158 191 125 235 181 105 37 145 227 154 107 228 197 165 158 149 126 96 233 171 60 241 33 29 223 210 202 237 115 16 46 253 100 141 64 63 4 237 189 143 195 34 56 37 56 223 99 100 61 80 224 129 3 78 184 5 78 233 189 247 65 138 51 126 184 190 166 169 133 82 26 156 159 100 146 37 204 68 39 26 83 163 140 46 80 119 221 55 69 202 52 228 247 254 196 114 43 226 180 240 192 99 88 185 78 187 0 223 160 26 148 237 99 254 164 13 10 201 236 232 147 237 184 59 179 227 237 187 255 126 66 240 62 210 14 84 238 141 16 48 142 57 232 84 223 26 59 136 146 184 229 93 115 187 251 101 41 224 127 129 64 216 190 149 207 181 0 161 183 183 203 250 184 244 162 122 248 240 123 81 193 35 244 75 82 191 3 248 227 223 206 136 154 124 226 127 39 239 138 159 0 153 128 135 59 24 48 15 117 184 3 31 214 227 0 71 64 34 127 250 131 32 4 199 247 177 1 90 16 124 97 24 131 26 56 183 65 14 150 193 31 3 88 221 5 71 168 8 3 12 224 132 88 64 225 21 78 136 66 8 68 65 11 36 140 161 12 103 72 195 26 218 240 134 56 204 161 14 117 24 2 0 33 249 4 9 6 0 16 0 44 0 0 0 0 220 0 33 0 132 124 126 124 188 190 188 220 222 220 236 238 236 156 158 156 204 206 204 244 246 244 188 186 188 212 214 212 140 142 140 204 202 204 228 230 228 244 242 244 164 166 164 212 210 212 252 250 252 255 255 255 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 5 254 32 36 142 100 105 158 104 170 174 108 235 190 112 44 207 116 109 223 120 174 239 124 239 255 192 160 112 72 44 26 143 200 164 114 201 108 58 159 208 168 116 74 173 90 127 143 129 118 203 237 110 25 215 176 24 88 0 152 207 232 244 57 49 110 187 111 229 67 224 32 175 219 231 114 2 59 245 88 248 255 128 127 96 44 3 129 134 126 15 44 125 135 129 131 43 133 140 128 137 43 139 145 126 142 42 144 150 11 147 42 149 150 152 38 101 14 164 165 14 10 166 166 13 123 40 6 1 175 176 177 176 8 45 8 178 183 175 157 41 174 184 178 180 44 182 189 177 186 173 194 177 191 43 193 198 1 196 39 188 203 200 39 14 0 167 5 10 214 14 5 213 215 215 14 171 158 1 2 11 144 228 126 10 209 41 8 10 229 227 126 3 2 204 44 174 226 236 144 231 45 2 10 237 251 144 240 205 38 243 248 185 51 135 14 69 62 129 251 252 201 11 135 208 94 65 18 211 178 73 44 160 173 155 182 138 223 118 49 108 184 224 30 48 125 127 216 41 92 193 32 92 161 122 29 254 31 154 80 55 80 224 72 21 1 57 122 92 113 170 101 185 151 26 197 201 84 41 98 26 170 107 23 47 102 11 154 17 197 3 147 145 102 170 96 121 210 144 128 3 255 74 28 213 201 72 105 58 144 140 112 162 40 73 175 42 79 18 44 35 105 61 193 117 159 33 171 37 20 80 19 250 83 40 197 108 69 157 109 52 251 7 237 137 176 89 227 145 68 122 104 128 221 149 250 52 133 92 240 52 42 137 169 129 4 255 45 193 212 80 161 194 138 230 30 90 12 33 226 91 160 67 223 106 243 198 234 4 98 64 229 40 143 104 60 248 177 94 112 84 217 165 172 133 149 46 97 168 44 202 58 38 200 26 116 32 200 123 169 46 96 112 137 118 138 136 109 39 158 26 122 45 46 64 190 174 81 213 102 244 14 118 110 219 251 68 139 32 221 174 159 115 79 7 186 54 173 251 117 116 224 210 126 112 99 239 58 249 171 218 160 19 47 11 53 46 117 163 38 77 210 33 80 191 125 61 133 108 222 103 29 44 207 90 127 171 100 219 202 125 100 137 120 246 205 165 26 101 192 5 254 197 86 69 112 117 118 92 106 137 5 152 76 107 248 89 103 216 8 83 9 54 152 132 75 181 38 82 127 158 185 55 153 126 2 162 244 218 133 34 124 54 27 101 106 9 87 145 102 235 57 40 85 118 150 112 120 213 128 32 154 32 91 75 117 145 56 161 106 127 16 232 159 110 130 249 229 99 135 56 162 8 129 108 219 113 167 130 101 12 162 194 224 101 236 145 16 147 134 190 253 40 86 142 51 234 84 164 57 71 222 216 215 137 138 208 72 151 61 97 26 244 221 151 66 122 102 230 138 230 81 211 214 130 232 85 137 225 127 138 165 121 23 86 245 180 169 35 114 103 117 55 221 119 174 249 89 194 142 35 238 55 88 120 92 146 192 228 162 171 253 182 86 122 46 74 100 167 8 188 200 161 0 29 7 108 186 233 1 130 66 240 212 43 116 124 250 169 28 74 30 197 169 167 165 114 26 234 168 173 118 42 43 170 145 193 194 170 169 7 232 185 18 169 1 156 138 107 170 176 196 58 43 168 79 2 16 220 139 67 85 195 153 39 174 25 18 10 10 77 97 233 78 170 60 93 58 54 64 11 188 73 43 137 34 213 58 139 109 179 129 80 11 174 59 215 166 208 34 122 82 34 75 209 165 111 180 235 110 9 211 112 42 239 188 242 234 241 238 189 248 150 80 134 26 252 162 33 99 190 0 183 241 0 3 3 16 108 112 193 8 31 204 0 193 1 55 236 240 195 16 71 44 241 196 20 87 108 241 197 24 103 172 241 198 28 191 16 2 0 59) asByteArray! !

!DCD6FileLibrary methodsFor: 'as yet unclassified' stamp: 'fredaebi 3/26/2012 13:04'!
versionJs
^ '
function checkVersions() {
	nbChecked = 0;
	size = document.getElementById("version-size").value;
	for(i=0;i<size;i++)
		if (document.getElementById("version-checkbox-"+i).checked)
			nbChecked++;	
	if (nbChecked == 0) {
		alert("Please select at lease one version.");
		return false;
	} else {
		document.getElementById("progress").style.visibility = "visible";
		return true;
	}
}

function selectAll() {
	size = document.getElementById("version-size").value;
	for(i=0;i<size;i++)
		document.getElementById("version-checkbox-"+i).checked = true;
}

function unselectAll() {
	size = document.getElementById("version-size").value;
	for(i=0;i<size;i++)
		document.getElementById("version-checkbox-"+i).checked = false;
}

function selectMonth(number) {
	unselectAll();
	lastSelectedMonth = 0;
	size = document.getElementById("version-size").value;
	month = getFirstMonth();
	validMonths = getValidMonths(month, number);
	for(i=0;i<size;i++) {
		date = document.getElementById("version-date-"+i).value;
		for(j=0;j<validMonths.length;j++) {
			if (getMonth(date) == validMonths[j] && lastSelectedMonth !!= validMonths[j]) {
				document.getElementById("version-checkbox-"+i).checked = true;	
				lastSelectedMonth = validMonths[j];
			}	
		}
	}
}

function getFirstMonth() {
	size = document.getElementById("version-size").value;
	for(i=0;i<size;i++) {
		date = document.getElementById("version-date-"+i).value;
		if (date !!= "-")
			return getMonth(date);
	}
}

function getMonth(date) {
	array = date.split("-");
	return array[1];
}

function getValidMonths(month, number) {
	if (number == 3) {
		if (month == 1 || month == 4 || month == 7 || month == 10) return new Array(1,4,7,10);
		if (month == 2 || month == 5 || month == 8 || month == 11) return new Array(2,5,8,11);
		if (month == 3 || month == 6 || month == 9 || month == 12) return new Array(3,6,9,12);
	} else if (number == 1)
		return new Array(1,2,3,4,5,6,7,8,9,10,11,12);
}
'.! !

WAComponent subclass: #DCD6
	instanceVariableNames: 'detector nbSuspects currentCaseStudy currentPage currentPageContent versions topSuspects randomSuspects ignoredSuspects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DCD6'!

!DCD6 class methodsFor: 'as yet unclassified' stamp: 'fredaebi 3/23/2012 08:57'!
canBeRoot
	^ true! !

!DCD6 methodsFor: 't6-helpers' stamp: 'fredaebi 3/27/2012 09:54'!
computeBelonging: aBelonging
	| belonging search returnValue |
	
	belonging := aBelonging asString.
	(belonging indexOfSubCollection: 'Smalltalk (Namespace)') ~= 0
	ifTrue: [returnValue := '-'.]
	ifFalse: [
		(belonging indexOfSubCollection: ' in Smalltalk (Class)') ~= 0
		ifTrue: [returnValue := belonging copyFrom: 1 to: (belonging indexOfSubCollection: ' in Smalltalk (Class)').].].
	^ returnValue.! !

!DCD6 methodsFor: 't6-helpers' stamp: 'aebif 4/17/2012 18:54'!
computeSuspects
	| selectedVersions configurationString |
 
	detector := DCD6Detector new.
	selectedVersions := OrderedCollection new.
	configurationString  := 'ConfigurationOf',currentCaseStudy.
	versions do: [:version | 
		version selected
		ifTrue: [selectedVersions add: version.].].
	selectedVersions := selectedVersions sortedAs: [:x :y | x number < y number].
	selectedVersions isEmpty
	ifFalse: [selectedVersions do: [:version | detector loadModelFromSmalltalkCategory: currentCaseStudy configuration: configurationString version: (version number asString).].
		[((Smalltalk at: (configurationString asSymbol)) project version: (selectedVersions last number asString)) load.] on: UndeclaredVariableWarning  do: [:e | e resume: false.].	
		detector runTestsFromPackage: currentCaseStudy,'*'.
		detector setAllSuspects.
		"Gofer new package: currentCaseStudy; unload."
		versions := OrderedCollection new.].! !

!DCD6 methodsFor: 't6-helpers' stamp: 'fredaebi 3/27/2012 09:59'!
computeType: aType
	| type |
	
	type := aType asString.
	^ type copyFrom: 6 to: type size.! !

!DCD6 methodsFor: 't6-helpers' stamp: 'fredaebi 3/18/2012 10:02'!
computeVersionDate: aVersion
	| versionDate y m d |
	
	versionDate := aVersion timestamp asString.
	(versionDate indexOf: $/) = 0
	ifTrue: [^ '-'.]
	ifFalse: [
		versionDate := versionDate copyFrom: 1 to: ((versionDate indexOf: $ )-1).
		m := versionDate copyFrom: 1 to: ((versionDate indexOf: $/)-1).
		d := versionDate copyFrom: ((versionDate indexOf: $/)+1) to: ((versionDate lastIndexOf: $/)-1).
		y := versionDate copyFrom: ((versionDate lastIndexOf: $/)+1) to: ((versionDate lastIndexOf: $/)+4).
		^ y,'-',m,'-',d.].! !

!DCD6 methodsFor: 't6-helpers' stamp: 'fredaebi 3/18/2012 09:18'!
computeVersionString: aVersion
	| version from to |
	
	version := aVersion asString.
	(version indexOf: $<) = 0 & (version indexOf: $>) = 0 & (version indexOf: $=) = 0
	ifTrue: [from := 1.]
	ifFalse: [from := 3.].
	to := (version indexOf: $ )-1.
	^ (version copyFrom: from to: to).! !

!DCD6 methodsFor: 't6-helpers' stamp: 'fredaebi 3/18/2012 10:03'!
computeVersionTime: aVersion
	| versionTime |
	
	versionTime := aVersion timestamp asString.
	(versionTime indexOf: $/) = 0
	ifTrue: [^ '-'.]
	ifFalse: [^ versionTime copyFrom: ((versionTime indexOf: $ )+1) to: ((versionTime indexOf: $ )+5).].! !

!DCD6 methodsFor: 't6-helpers' stamp: 'aebif 4/17/2012 18:56'!
computeVersions
	| configurationString configuration version |
	
	versions := OrderedCollection new.
	configurationString := 'ConfigurationOf',currentCaseStudy.
	configuration := Gofer new squeaksource: currentCaseStudy; package: configurationString; load.
	
	((Smalltalk at: (configurationString asSymbol)) project versions) do: [:aVersion |
		version := DCD6Version new.
		version number: (self computeVersionString: aVersion).
		version date: (self computeVersionDate: aVersion).
		version time: (self computeVersionTime: aVersion).
		version selected: false.
		versions add: version.].
	
	 versions := versions sortedAs: [:x :y | x number > y number].! !

!DCD6 methodsFor: 'accessing' stamp: 'fredaebi 3/13/2012 08:35'!
currentCaseStudy
	^ currentCaseStudy.! !

!DCD6 methodsFor: 'accessing' stamp: 'fredaebi 3/13/2012 08:35'!
currentCaseStudy: aCaseStudy
	currentCaseStudy := aCaseStudy.! !

!DCD6 methodsFor: 'accessing' stamp: 'fredaebi 3/16/2012 20:10'!
currentPage
	^ currentPage.! !

!DCD6 methodsFor: 'accessing' stamp: 'fredaebi 4/17/2012 08:19'!
currentPage: aPage
	versions := OrderedCollection new.
	ignoredSuspects := OrderedCollection new.
	detector := nil.
	currentPage := aPage.! !

!DCD6 methodsFor: 'initialization' stamp: 'fredaebi 4/17/2012 08:17'!
initialize
	super initialize.
	nbSuspects := 10.! !

!DCD6 methodsFor: 'initialization' stamp: 'aebif 4/17/2012 18:55'!
initializeSuspects: aCollection
	| suspects suspect |
	
	suspects := OrderedCollection new.
	aCollection isEmptyOrNil
	ifFalse: [
		aCollection do: [:each | 
			suspect := DCD6Suspect new.
			suspect belonging: (self computeBelonging: each belongsTo).
			suspect entity: each name.
			suspect type: (self computeType: each class).
			suspect numberOfLinesOfCode: each numberOfLinesOfCode.
			suspect valid: 'on'.
			suspects add: suspect.].].
	^ suspects.! !

!DCD6 methodsFor: 'accessing' stamp: 'aebif 4/17/2012 18:55'!
library
	^ DCD6FileLibrary.! !

!DCD6 methodsFor: 'accessing' stamp: 'fredaebi 3/12/2012 07:50'!
randomSuspects
	^ randomSuspects.! !

!DCD6 methodsFor: 'accessing' stamp: 'fredaebi 3/12/2012 07:50'!
randomSuspects: aCollection
	randomSuspects := aCollection.! !

!DCD6 methodsFor: 't6-helpers' stamp: 'fredaebi 4/17/2012 08:17'!
recomputeSuspects
	topSuspects isEmptyOrNil
	ifFalse: [
	topSuspects do: [:aSuspect |
		aSuspect valid
		ifFalse: [ignoredSuspects add: aSuspect.].].].
	randomSuspects isEmptyOrNil
	ifFalse: [
	randomSuspects do: [:aSuspect | 
		aSuspect valid
		ifFalse: [ignoredSuspects add: aSuspect.].].].
	detector setAllSuspectsWithout: ignoredSuspects.! !

!DCD6 methodsFor: 'rendering' stamp: 'fredaebi 3/17/2012 14:12'!
renderAboutPageOn: html! !

!DCD6 methodsFor: 'rendering' stamp: 'fredaebi 3/27/2012 08:09'!
renderCaseStudiesPageOn: html
	html paragraph: [
		html text: 'If you want your Smalltalk code to be analyzed by T6, please make sure that you have a '.
		html anchor url: 'http://source.lukas-renggli.ch/@pu7HtiHWxPbVocQd/auLvZa9h'; target: '_blank'; with: 'Gofer'.
		html text: ' Configuration of your Smalltalk project.'.].
	html paragraph: 'T6 uses the configuration to collect all its versions. You can then select the versions you would like to include in the dead code analysis.'.
	html break.
	html paragraph: 'Below is a list of case studies on which T6 can be applied. You can select one to see its versions and to perform the analysis.'.
	html unorderedList: [
		html listItem: [
			html anchor
        			callback: [ self currentCaseStudy: 'Roassal'. self computeVersions. ];
        			with: 'Roassal'.].
      	html listItem: [
			html anchor
        			callback: [ self currentCaseStudy: 'Mondrian'. self computeVersions. ];
        			with: 'Mondrian'.].
      	html listItem: [
			html anchor
        			callback: [ self currentCaseStudy: 'Versionner'. self computeVersions. ];
        			with: 'Versionner'.].
      	html listItem: [
			html anchor
        			callback: [ self currentCaseStudy: 'Merlin'. self computeVersions. ];
        			with: 'Merlin'.].
      	html listItem: [
			html anchor
        			callback: [ self currentCaseStudy: 'Spy'. self computeVersions. ];
        			with: 'Spy'.].].
	html break.
	self renderVersionSelectionOn: html.
	self renderSuspectSelectionOn: html.! !

!DCD6 methodsFor: 'rendering' stamp: 'fredaebi 4/17/2012 08:00'!
renderContentOn: html
	self renderHeaderOn: html.
	self renderPageOn: html.
! !

!DCD6 methodsFor: 'rendering' stamp: 'fredaebi 3/17/2012 14:11'!
renderDownloadsPageOn: html! !

!DCD6 methodsFor: 'rendering' stamp: 'fredaebi 3/17/2012 19:10'!
renderFAQPageOn: html
	html unorderedList: [
		html listItem: [
			html anchor
				url: '#what-is-dead-code';
				with: 'What is dead code?'].
		html listItem: [
			html anchor
				url: '#how-does-t6-detect-dead-code';
				with: 'How does T6 detect dead code?'].	
		html listItem: [
			html anchor
				url: '#what-is-static-analysis';
				with: 'What is static analysis?'].	
		html listItem: [
			html anchor
				url: '#what-is-dynamic-analysis';
				with: 'What is dynamic analysis?'].].! !

!DCD6 methodsFor: 'rendering' stamp: 'fredaebi 3/17/2012 14:34'!
renderHeaderOn: html
	html div
		id: 'header'; 
		with: [
			html div: [
				html heading: 'T6 Dead Code Detection Tool'.].
			html unorderedList: [
				html listItem: [
					html anchor
       		 			callback: [self currentPage: 'About'.];
    			    			with: 'About'.].
				html listItem: [
					html anchor
       		 			callback: [self currentPage: 'Downloads'.];
    			    			with: 'Downloads'.].
				html listItem: [
					html anchor
       		 			callback: [self currentPage: 'Case Studies'.];
    			    			with: 'Case Studies'.].
				html listItem: [
					html anchor
       		 			callback: [self currentPage: 'Frequently Asked Questions'.];
    			    			with: 'FAQ'.].
				html listItem: [
					html anchor
       		 			callback: [self currentPage: 'Home'.];
    			    			with: 'Home'.].].].
! !

!DCD6 methodsFor: 'rendering' stamp: 'fredaebi 3/26/2012 18:56'!
renderHomePageOn: html
	html paragraph: 'Welcome to the T6 Dead Code Detection Tool.'.
	html paragraph: 'This tool allows you to analyze your Smalltalk code and to get feedback about dead code.'.
	html break.
	html heading level: 3; with: 'How To'.
	html orderedList: [
		html listItem: [
			html text: 'Verify that you have a '.
			html anchor url: 'http://source.lukas-renggli.ch/@pu7HtiHWxPbVocQd/auLvZa9h'; target: '_blank'; with: 'Gofer'.
			html text: ' configuration for your project.'.].
		html listItem: [
			html text: 'Go to the '.
			html anchor callback: [self currentPage: 'Case Studies'.]; target: '_blank'; with: 'Case Studies'.
			html text: ' tab and select a case study.'].
		html listItem: [
			html text: 'Select the versions you would like to include in the analysis.'.].
		html listItem: [
			html text: 'Click on "Perform Analysis" to start the analysis.'.].].! !

!DCD6 methodsFor: 'rendering' stamp: 'fredaebi 3/26/2012 19:01'!
renderPageOn: html
	html div
		id: 'content'; 
		with: [
			currentPage isNil ifTrue: [self currentPage: 'Home'].
			html heading level: 2; with:currentPage.
			currentPage = 'Home' ifTrue: [self renderHomePageOn:html.].
			currentPage = 'Frequently Asked Questions' ifTrue: [self renderFAQPageOn:html].
			currentPage = 'Case Studies' ifTrue: [self renderCaseStudiesPageOn:html].
			currentPage = 'Downloads'	ifTrue: [self renderDownloadsPageOn:html.].
			currentPage = 'About' ifTrue: [self renderAboutPageOn:html.].].! !

!DCD6 methodsFor: 'rendering' stamp: 'fredaebi 4/17/2012 08:15'!
renderSuspectSelectionOn: html
	
	detector isNil
	ifFalse: [
		topSuspects := self initializeSuspects: (detector getTopSuspects: nbSuspects).
		randomSuspects := self initializeSuspects: (detector getRandomSuspects: nbSuspects).
		html form: [
			html submitButton on: #recomputeSuspects of: self.
			html break.
			html break.
			html heading level: 3; with: 'Top 10 Suspects'.
			html table
				id: 'suspects';
				with: [
					html tableRow: [
						html tableHeading class: 'big'; with: 'Entity'.
						html tableHeading class: 'big'; with: 'BelongsTo'.
						html tableHeading class: 'small'; with: 'Type'.
						html tableHeading class: 'small'; with: 'Lines of Code'.
						html tableHeading class: 'small'; with: 'Validation'.].
					topSuspects do: [ :each |
						html tableRow: [
						html tableData class: 'entity'; with: each entity.
						html tableData class: 'belongsTo'; with: each belonging.
						html tableData: each type.
						html tableData: each numberOfLinesOfCode.
						html tableData: [html checkbox value: each valid; callback: [:value | each valid: value.].].].].].
			html break.
			html heading level: 3; with: 'Random 10 Suspects'.
			html table
				id: 'suspects';
				with: [
					html tableRow: [
						html tableHeading class: 'big'; with: 'Entity'.
						html tableHeading class: 'big'; with: 'BelongsTo'.
						html tableHeading class: 'small'; with: 'Type'.
						html tableHeading class: 'small'; with: 'Lines of Code'.
						html tableHeading class: 'small'; with: 'Validation'.].
					randomSuspects do: [ :each |
						html tableRow: [
						html tableData class: 'entity'; with: each entity.
						html tableData class: 'belongsTo'; with: each belonging.
						html tableData: each type.
						html tableData: each numberOfLinesOfCode.
						html tableData: [html checkbox value: each valid; callback: [:value | each valid: value.].].].].].].].! !

!DCD6 methodsFor: 'rendering' stamp: 'fredaebi 3/27/2012 08:13'!
renderVersionSelectionOn: html
	| cpt |
	
	cpt := 0.
	versions isEmptyOrNil
	ifFalse: [
		html heading level: 3; with: 'Selected Case Study : ',self currentCaseStudy.
		html textInput id: 'version-size'; type: 'hidden'; value: versions size.
		html anchor url: 'javascript:void(0)'; onClick: 'selectAll()'; with: 'Select all'. html text: ' / '.
		html anchor url: 'javascript:void(0)'; onClick: 'unselectAll()'; with: 'Unselect all'. html text: ' / '.
		html anchor url: 'javascript:void(0)'; onClick: 'selectMonth(1)'; with: 'Select one version every month'. html text: ' / '.
		html anchor url: 'javascript:void(0)'; onClick: 'selectMonth(3)'; with: 'Select one version every 3 months'. html break.
		html break.
		html form
			onSubmit: 'return checkVersions()';
			with: [
				html submitButton on: #computeSuspects of: self; with: 'Perform Analysis'.
				html break.
				html break.
				html div
					id: 'progress';
					with: [html image url: (self library urlOf: #spinnerGif).].
				html break.
				html table
					id: 'versions';
					with: [
						html tableRow: [
							html tableHeading: 'Version'.
							html tableHeading: 'Date'.
							html tableHeading: 'Time'.
							html tableHeading class: 'center'; with: 'Include in Analysis'.].
						versions do: [ :version |
							html tableRow: [
								html tableData: version number.
								html tableData: version date.
								html tableData: version time.
								html tableData class: 'center'; with: [
									html textInput id: ('version-id-',(cpt asString)); type: 'hidden'; value: version number.
									html textInput id: ('version-date-',(cpt asString)); type: 'hidden'; value: version date.
									html checkbox id: ('version-checkbox-',(cpt asString)); value: version selected; callback: [:value | version selected: value.].].].
							cpt := cpt + 1.].].].].! !

!DCD6 methodsFor: 'accessing' stamp: 'fredaebi 3/12/2012 07:50'!
topSuspects
	^ topSuspects.! !

!DCD6 methodsFor: 'accessing' stamp: 'fredaebi 3/12/2012 07:50'!
topSuspects: aCollection
	topSuspects := aCollection.! !

!DCD6 methodsFor: 'updating' stamp: 'fredaebi 3/23/2012 21:57'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	anHtmlRoot title: 'T6 Dead Code Detection Tool'.
	anHtmlRoot stylesheet url: 'http://ajax.googleapis.com/ajax/libs/jqueryui/1.8/themes/base/jquery-ui.css'.
	anHtmlRoot stylesheet url: (self library urlOf: #layoutCss).
	anHtmlRoot javascript url: 'http://ajax.googleapis.com/ajax/libs/jquery/1.5/jquery.min.js'.
	anHtmlRoot javascript url: 'http://ajax.googleapis.com/ajax/libs/jqueryui/1.8/jquery-ui.min.js'.
	anHtmlRoot javascript url: (self library urlOf: #versionJs).
	! !

!DCD6 methodsFor: 'accessing' stamp: 'fredaebi 3/16/2012 14:26'!
versions
	^ versions.! !

!DCD6 methodsFor: 'accessing' stamp: 'fredaebi 3/16/2012 14:26'!
versions: aCollection
	versions := aCollection.! !

MethodSpy subclass: #DCD6TestCoverageMethod
	instanceVariableNames: 'numberOfExecutions receiverTable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DCD6'!

!DCD6TestCoverageMethod methodsFor: 'as yet unclassified' stamp: 'aebif 12/7/2011 17:56'!
beforeRun: methodSelector with: args in: receiver 
	numberOfExecutions := numberOfExecutions + 1. 
	receiverTable add: receiver.! !

!DCD6TestCoverageMethod methodsFor: 'as yet unclassified' stamp: 'aebif 12/6/2011 08:10'!
initialize
	super initialize.
	numberOfExecutions := 0.
	receiverTable := BoundedIdentitySet maxSize: 100! !

!DCD6TestCoverageMethod methodsFor: 'as yet unclassified' stamp: 'aebif 12/6/2011 08:15'!
isCovered
	^ numberOfExecutions > 0! !

!DCD6TestCoverageMethod methodsFor: 'as yet unclassified' stamp: 'aebif 12/6/2011 08:15'!
numberOfDifferentReceivers
	^ (receiverTable select: #notNil) size! !

!DCD6TestCoverageMethod methodsFor: 'as yet unclassified' stamp: 'aebif 12/6/2011 08:15'!
numberOfExecutions 
	^ numberOfExecutions! !

PackageSpy subclass: #DCD6TestCoveragePackage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DCD6'!

!DCD6TestCoveragePackage class methodsFor: 'as yet unclassified' stamp: 'aebif 4/17/2012 18:55'!
spyClassForClass
	^ DCD6TestCoverageClass! !

ClassSpy subclass: #DCD6TestCoverageClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DCD6'!

!DCD6TestCoverageClass class methodsFor: 'as yet unclassified' stamp: 'aebif 4/17/2012 18:56'!
spyClassForMethod
	^ DCD6TestCoverageMethod! !

Object subclass: #DCD6Detector
	instanceVariableNames: 'versionMooseModelCollection externalMooseModelCollection counterDeadMethods counterDeadClasses dynamicPackageName suspects msePath'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DCD6'!

!DCD6Detector methodsFor: 'public' stamp: 'fredaebi 3/26/2012 19:24'!
addExternalSystemModelFromFile: aFile
	externalMooseModelCollection add: (MooseModel new importFromMSEStream: (StandardFileStream readOnlyFileNamed: aFile)).! !

!DCD6Detector methodsFor: 'public' stamp: 'fredaebi 3/26/2012 19:14'!
addVersionModelFromFile: aFile
	versionMooseModelCollection add: (MooseModel new importFromMSEStream: (StandardFileStream readOnlyFileNamed: aFile)).! !

!DCD6Detector methodsFor: 'public' stamp: 'fredaebi 3/26/2012 19:24'!
browseForSuspect: aSuspectName
	^ self getAllSuspects do: [:each | 
	each name =  aSuspectName
	ifTrue: [
		Transcript 	show: 'entity : ';
					show: each name;
					show: ', type : ';
					show: each class;
					show: ', numberOfLinesOfCode : ';
					show: each numberOfLinesOfCode; cr.].].! !

!DCD6Detector methodsFor: 'helpers' stamp: 'fredaebi 3/26/2012 19:23'!
compareFrom: aFirstCollectionOfReceivers to: aSecondCollectionOfReceivers
	| unchangedReceiversTmp unchangedReceivers changedReceivers unchangedReceiver |
	
	unchangedReceiversTmp := OrderedCollection new.
	unchangedReceivers := OrderedCollection new.
	changedReceivers := OrderedCollection new.
	aFirstCollectionOfReceivers do: [:eachFromFirst |
		aSecondCollectionOfReceivers do: [:eachFromSecond  |
			(eachFromFirst name = eachFromSecond name)
			ifTrue:[(eachFromFirst numberOfLinesOfCode = eachFromSecond numberOfLinesOfCode)
				ifTrue:[unchangedReceiversTmp add: eachFromSecond.]
				ifFalse:[changedReceivers add: eachFromSecond].].
			unchangedReceiversTmp isEmpty
			ifTrue:[unchangedReceiver := eachFromFirst.].
			unchangedReceiversTmp removeAll.].		
		(changedReceivers includes: unchangedReceiver)
		ifFalse:[unchangedReceivers add: unchangedReceiver.].].
	^ unchangedReceivers! !

!DCD6Detector methodsFor: 'accessing' stamp: 'aebif 12/7/2011 16:01'!
counterDeadClasses
	^ counterDeadClasses! !

!DCD6Detector methodsFor: 'accessing' stamp: 'aebif 12/7/2011 16:01'!
counterDeadClasses: aCounterDeadClasses
	counterDeadClasses := aCounterDeadClasses! !

!DCD6Detector methodsFor: 'accessing' stamp: 'aebif 12/7/2011 16:01'!
counterDeadMethods
	 ^ counterDeadMethods! !

!DCD6Detector methodsFor: 'accessing' stamp: 'aebif 12/7/2011 16:01'!
counterDeadMethods: aCounterDeadMethods
	counterDeadMethods := aCounterDeadMethods! !

!DCD6Detector methodsFor: 'helpers' stamp: 'aebif 4/17/2012 18:55'!
dynamicAnalysis
	| coverage |
	
	coverage := OrderedCollection new.
	dynamicPackageName = '' 
	ifFalse: [
		coverage := DCD6TestCoverage 
		profile: [ MOViewRendererTest buildSuite run ] inPackagesMatching: dynamicPackageName.].
	^ coverage.! !

!DCD6Detector methodsFor: 'accessing' stamp: 'aebif 12/7/2011 16:01'!
dynamicPackageName
	^ dynamicPackageName! !

!DCD6Detector methodsFor: 'accessing' stamp: 'aebif 12/7/2011 16:01'!
dynamicPackageName: aDynamicPackageName
	dynamicPackageName:= aDynamicPackageName! !

!DCD6Detector methodsFor: 'helpers' stamp: 'fredaebi 3/26/2012 19:19'!
ecosystemAnalysis
	| stubClasses |
	
	stubClasses := OrderedCollection new.
	externalMooseModelCollection isEmpty
	ifFalse: [
	externalMooseModelCollection do: [ :eachModel | 
		eachModel allClasses do: [ :eachClass |
			eachClass isStub
			ifTrue: [stubClasses add: eachClass.].].].].
	^ stubClasses! !

!DCD6Detector methodsFor: 'accessing' stamp: 'aebif 12/8/2011 19:14'!
externalMooseModelCollection
	^ externalMooseModelCollection! !

!DCD6Detector methodsFor: 'accessing' stamp: 'aebif 12/8/2011 19:14'!
externalMooseModelCollection: aCollection
	externalMooseModelCollection := aCollection.! !

!DCD6Detector methodsFor: 'public' stamp: 'fredaebi 3/26/2012 19:25'!
getRandomSuspects: aNumber
	| randomSuspects totalNumberOfLinesOfCode randomIndex count suspect |
		
	randomSuspects := OrderedCollection new.
	totalNumberOfLinesOfCode := 0.
	suspects size > aNumber
	ifTrue: [
		count := 0.
		[count < aNumber] whileTrue: [
			randomIndex := (1 to: suspects size) atRandom.
			suspect := suspects at: randomIndex.
			totalNumberOfLinesOfCode := totalNumberOfLinesOfCode + (suspect numberOfLinesOfCode).
			count := count + 1.
			randomSuspects add: suspect.].] 
	ifFalse: [
	suspects do: [ :each | 					
		totalNumberOfLinesOfCode := totalNumberOfLinesOfCode + (each numberOfLinesOfCode).
		randomSuspects add: each.].].	
	^ randomSuspects.! !

!DCD6Detector methodsFor: 'public' stamp: 'fredaebi 3/26/2012 19:25'!
getTopSuspects: aNumber
	| topSuspects totalNumberOfLinesOfCode |
		
	topSuspects := OrderedCollection new.
	totalNumberOfLinesOfCode := 0.
	suspects size > aNumber
	ifTrue: [
		suspects from: 1 to: aNumber do: [ :each |
			totalNumberOfLinesOfCode := totalNumberOfLinesOfCode + (each numberOfLinesOfCode).
			topSuspects add: each.].]
	ifFalse: [
		suspects do: [ :each |		
			totalNumberOfLinesOfCode := totalNumberOfLinesOfCode + (each numberOfLinesOfCode).
			topSuspects add: each.].].	
	^ topSuspects.! !

!DCD6Detector methodsFor: 'helpers' stamp: 'aebif 4/17/2012 18:54'!
groupByClass: aSetOfSuspect
	| classCounterTmp aDeadCodeDectorClass emptyCollection |
	
	classCounterTmp := OrderedCollection new.
	emptyCollection := OrderedCollection new.
	"loop suspect and increment counter of class methods"
	aSetOfSuspect do:[:each | 		
		"if the class exists already in the collection, increment the counter"
		classCounterTmp do:[:eachTmp | 
			(eachTmp nameClass name = each belongsTo name)
			ifTrue: [
				eachTmp counterFind: (eachTmp counterFind + 1).
				emptyCollection add: eachTmp.].].
			"if the class do not exists, add it to the collection with counter =  1"
			(emptyCollection isEmpty)
			ifTrue: [
				aDeadCodeDectorClass := DCD6DetectorClass new.
				aDeadCodeDectorClass nameClass:  each belongsTo.
				aDeadCodeDectorClass counterFind: 1.
				aDeadCodeDectorClass counterTotal: each belongsTo methods size.
				classCounterTmp add: aDeadCodeDectorClass.].				
			emptyCollection := OrderedCollection new.].
		"compare the number of dead methods to the total number of a class"
		classCounterTmp do:[:eachTest | 
			(eachTest counterTotal = eachTest counterFind) 
			ifTrue: [ 
				aSetOfSuspect do:[:eachSuspectToDelete | 
					"if counters are equal, regroup suspect by classes"
					(eachTest nameClass name = eachSuspectToDelete belongsTo name)
					ifTrue: [aSetOfSuspect remove: eachSuspectToDelete.].].
				aSetOfSuspect add: eachTest nameClass].].
	^ aSetOfSuspect! !

!DCD6Detector methodsFor: 'initialize-release' stamp: 'fredaebi 3/26/2012 13:18'!
initialize
	versionMooseModelCollection := OrderedCollection new.
	externalMooseModelCollection := OrderedCollection new.
	suspects := OrderedCollection new.
	dynamicPackageName := ''.
	msePath := SmalltalkImage current imagePath,'/mse/'.! !

!DCD6Detector methodsFor: 'public' stamp: 'fredaebi 4/17/2012 10:47'!
loadModelFromSmalltalkCategory: aCategory configuration:aConfiguration version: aVersion
	| mooseModel categories importer modelFile |

	mooseModel := MooseModel new.
	mooseModel name: aCategory,'_',aVersion.
	modelFile := (msePath asString),mooseModel name,'.mse'.
	(FileDirectory new fileExists: modelFile)
	ifTrue: [
		self addVersionModelFromFile: modelFile.]
	ifFalse: [
		[((Smalltalk at: (aConfiguration asSymbol)) project version: aVersion) load.] on: UndeclaredVariableWarning  do: [:e | e resume: false.].
		categories := (SystemOrganization categories) select: [:p | p beginsWith: aCategory].
		importer := MooseSqueakClassCategoryImporterTask new.
		importer importerClass: SmalltalkImporter.
		importer importingContext mergeClassAndMetaclass.
		importer model: mooseModel.
		importer addFromCategories: categories.
		importer runCandidateOperator.
		importer runWithProgress.
		mooseModel install.
		mooseModel exportToMSEStream: (StandardFileStream forceNewFileNamed: modelFile).
		versionMooseModelCollection add: mooseModel.
		mooseModel remove.].! !

!DCD6Detector methodsFor: 'helpers' stamp: 'fredaebi 3/26/2012 19:22'!
merge: aCollectionOfSuspects withEcosytem:  aCollectionOfEcosystemClasses
	| mergedSuspects |
	
	aCollectionOfEcosystemClasses isEmpty 
	ifTrue: [^ aCollectionOfSuspects.]
	ifFalse: [
		mergedSuspects := OrderedCollection new.
		aCollectionOfSuspects do: [ :aSuspect | 
		aCollectionOfEcosystemClasses do: [ :anEcosystemFAMIXClass | 
			aSuspect belongsTo name ~= anEcosystemFAMIXClass name
			ifTrue: [mergedSuspects add: aSuspect.].].].
		^ mergedSuspects asSet].! !

!DCD6Detector methodsFor: 'helpers' stamp: 'fredaebi 3/26/2012 19:23'!
mergeStatic: aCollectionOfStaticSuspects withDynamic:  aCollectionOfDynamicSuspects
	
	"Ugly hack to get around the fact that dynamic analysis (with SPY) doesn't return nice FAMIX Methods."
	| allMooseModelVersionsFAMIXMethods tmpMergedSuspects mergedSuspectNames mergedSuspects |
	
	allMooseModelVersionsFAMIXMethods := OrderedCollection new.
	tmpMergedSuspects := OrderedCollection new.
	mergedSuspectNames := OrderedCollection new.
	mergedSuspects := OrderedCollection new.
	"Adding all MooseModel versions' FAMIXmethods to a collection"
	versionMooseModelCollection do: [ :aMooseModel | 
		allMooseModelVersionsFAMIXMethods addAll: aMooseModel allMethods.].
	"Adding the names of all the suspects (found after static and dynamic analysis) to a collection"
	aCollectionOfStaticSuspects do: [ :aStaticSuspect | 
		mergedSuspectNames add: aStaticSuspect name.].
	aCollectionOfDynamicSuspects do: [ :aDynamicSuspect | 
		mergedSuspectNames add: aDynamicSuspect selector asString.].
	"Avoid duplications"
	mergedSuspectNames := mergedSuspectNames asSet.
	"Loop through all suspect names and find the corresponding FAMIXmethod object"
	mergedSuspectNames do: [ :aSuspect | 
		allMooseModelVersionsFAMIXMethods do: [:aFAMIXMethodFromMooseModelVersion | 
			aSuspect = aFAMIXMethodFromMooseModelVersion name
			ifTrue: [tmpMergedSuspects add: aFAMIXMethodFromMooseModelVersion.].].
		"If a FAMIXmethod has been found, add it to a collection"
		tmpMergedSuspects isEmpty
		ifFalse: [mergedSuspects add: tmpMergedSuspects first.].
		tmpMergedSuspects removeAll.].
	"Contains all FAMIXmethod objects that match to the suspects found after static and dynamic analysis"
	^ mergedSuspects! !

!DCD6Detector methodsFor: 'helpers' stamp: 'fredaebi 3/26/2012 19:23'!
notInvokedReceivers: aCollection
	| notInvokedReceivers |
	
	notInvokedReceivers := OrderedCollection new.
	aCollection do: [:each | 
		each queryAllIncomingInvocations isEmpty 
		ifTrue: [notInvokedReceivers add: each.].].
	^ notInvokedReceivers
! !

!DCD6Detector methodsFor: 'helpers' stamp: 'fredaebi 4/17/2012 07:32'!
removeModels
	externalMooseModelCollection isEmptyOrNil
	ifFalse: [
		externalMooseModelCollection do: [:model | 
			model remove.].].
	versionMooseModelCollection isEmptyOrNil
	ifFalse: [
		versionMooseModelCollection do: [:model | 
			model remove.].].! !

!DCD6Detector methodsFor: 'public' stamp: 'aebif 12/7/2011 16:10'!
runTestsFromPackage: aPackageName
	self dynamicPackageName: aPackageName.! !

!DCD6Detector methodsFor: 'public' stamp: 'fredaebi 4/17/2012 07:30'!
setAllSuspects
	| staticSuspects dynamicSuspects ecosystemFAMIXClasses |
	
	suspects := OrderedCollection new.
	staticSuspects := OrderedCollection new.
	dynamicSuspects := OrderedCollection new.
	ecosystemFAMIXClasses := OrderedCollection new.
	
	"Compares the first loaded MooseModel to each added versions of it"
	versionMooseModelCollection do: [ :eachModel |		
		eachModel ~= versionMooseModelCollection first
		ifTrue:[suspects addAll: (self compareFrom: (versionMooseModelCollection first) allMethods to: eachModel allMethods).].].
	
	"If no others version to compare"
	suspects isEmpty 
	ifTrue: [suspects:= versionMooseModelCollection first allMethods.].

	"Avoid duplications"
	suspects := suspects asSet.
	
	"Static analysis"
	staticSuspects := self notInvokedReceivers: suspects.
	
	"Dynamic analysis"
	dynamicSuspects := self dynamicAnalysis.
	"dynamicSuspects visualize."
	dynamicSuspects := dynamicSuspects allMethods select: [ :m | m numberOfExecutions = 0].
	
	"Ecosystem analysis"
	ecosystemFAMIXClasses := self ecosystemAnalysis.

	"Merge static and dynamic analysis"
	suspects := self  mergeStatic: staticSuspects withDynamic: dynamicSuspects.
		
	"Save number of dead methods"
	self counterDeadMethods: suspects size.
	
	"Performing a regrouping per class if it is possible"
	suspects := self groupByClass: suspects.
	
	"Comparing suspects with ecosystem analysis"
	suspects := self merge: suspects withEcosytem: ecosystemFAMIXClasses.
	
	"Save number of dead classes"
	self counterDeadClasses: self counterDeadMethods - suspects size .
	
	"Sort suspects according to their number of lines of code"
	suspects := suspects sortedAs: [:x :y | x numberOfLinesOfCode >= y numberOfLinesOfCode].	

	"Ignore tests"
	suspects do: [:aSuspect |
		('*Test*' match: aSuspect name)
		ifTrue: [suspects remove: aSuspect.].].! !

!DCD6Detector methodsFor: 'public' stamp: 'fredaebi 4/17/2012 07:29'!
setAllSuspectsWithout: ignoredSuspects
	| staticSuspects dynamicSuspects ecosystemFAMIXClasses |
	
	suspects := OrderedCollection new.
	staticSuspects := OrderedCollection new.
	dynamicSuspects := OrderedCollection new.
	ecosystemFAMIXClasses := OrderedCollection new.

	"Compares the first loaded MooseModel to each added versions of it"
	versionMooseModelCollection do: [ :eachModel |		
		eachModel ~= versionMooseModelCollection first
		ifTrue:[suspects addAll: (self compareFrom: (versionMooseModelCollection first) allMethods to: eachModel allMethods).].].
	
	"If no others version to compare"
	suspects isEmpty 
	ifTrue: [suspects:= versionMooseModelCollection first allMethods.].

	"Avoid duplications"
	suspects := suspects asSet.
	
	"Static analysis"
	staticSuspects := self notInvokedReceivers: suspects.
	
	"Dynamic analysis"
	dynamicSuspects := self dynamicAnalysis.
	"dynamicSuspects visualize."
	dynamicSuspects := dynamicSuspects allMethods select: [ :m | m numberOfExecutions = 0].
	
	"Ecosystem analysis"
	ecosystemFAMIXClasses := self ecosystemAnalysis.

	"Merge static and dynamic analysis"
	suspects := self  mergeStatic: staticSuspects withDynamic: dynamicSuspects.
		
	"Save number of dead methods"
	self counterDeadMethods: suspects size.
	
	"Performing a regrouping per class if it is possible"
	suspects := self groupByClass: suspects.
	
	"Comparing suspects with ecosystem analysis"
	suspects := self merge: suspects withEcosytem: ecosystemFAMIXClasses.
	
	"Save number of dead classes"
	self counterDeadClasses: self counterDeadMethods - suspects size .
	
	"Sort suspects according to their number of lines of code"
	suspects := suspects sortedAs: [:x :y | x numberOfLinesOfCode >= y numberOfLinesOfCode].	

	"Ignore tests"
	suspects do: [:aSuspect |
		('*Test*' match: aSuspect name)
		ifTrue: [suspects remove: aSuspect.].].
	
	"Ignore suspects we don't want to analyze"
	suspects do: [:aSuspect | 
		ignoredSuspects do: [:anIgnoredSuspect | 
			aSuspect name = anIgnoredSuspect entity
			ifTrue: [
				Transcript show: 'hello from ignore with '; show: aSuspect name; cr.
				suspects remove: aSuspect.].].].! !

!DCD6Detector methodsFor: 'accessing' stamp: 'fredaebi 3/11/2012 19:24'!
suspects
	^ suspects.! !

!DCD6Detector methodsFor: 'accessing' stamp: 'fredaebi 3/11/2012 19:24'!
suspects: aCollection
	suspects := aCollection.! !

!DCD6Detector methodsFor: 'accessing' stamp: 'aebif 12/8/2011 16:41'!
versionMooseModelCollection
	^ versionMooseModelCollection! !

!DCD6Detector methodsFor: 'accessing' stamp: 'aebif 12/8/2011 16:41'!
versionMooseModelCollection: aCollection
	versionMooseModelCollection := aCollection.! !

!DCD6Detector methodsFor: 'helpers' stamp: 'aebif 12/6/2011 15:26'!
visualize
	| view receivers |
	receivers := self mooseModel allModelClasses.
	view := MOViewRenderer new.
	view shape rectangle.
	view nodes: receivers.
	view edgesToAll: #providerClasses.
	view dominanceTreeLayout.
	view open.! !

Object subclass: #DCD6DetectorClass
	instanceVariableNames: 'nameClass counterFind counterTotal'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DCD6'!

!DCD6DetectorClass methodsFor: 'accessing' stamp: 'aebif 12/5/2011 18:31'!
counterFind
	^counterFind! !

!DCD6DetectorClass methodsFor: 'accessing' stamp: 'aebif 12/5/2011 18:31'!
counterFind:aCounterFind
	counterFind:=aCounterFind! !

!DCD6DetectorClass methodsFor: 'accessing' stamp: 'aebif 12/5/2011 18:31'!
counterTotal
	^counterTotal! !

!DCD6DetectorClass methodsFor: 'accessing' stamp: 'aebif 12/5/2011 18:32'!
counterTotal:aCounterTotal
	counterTotal:=aCounterTotal! !

!DCD6DetectorClass methodsFor: 'accessing' stamp: 'aebif 12/5/2011 18:32'!
nameClass 
	^nameClass! !

!DCD6DetectorClass methodsFor: 'accessing' stamp: 'aebif 12/5/2011 18:32'!
nameClass: aNameClass
	nameClass:=aNameClass! !

Object subclass: #DCD6Suspect
	instanceVariableNames: 'belonging entity type numberOfLinesOfCode valid'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DCD6'!

!DCD6Suspect methodsFor: 'accessing' stamp: 'fredaebi 3/12/2012 19:22'!
belonging
	^ belonging.! !

!DCD6Suspect methodsFor: 'accessing' stamp: 'fredaebi 3/12/2012 19:22'!
belonging: aBelonging
	belonging := aBelonging.! !

!DCD6Suspect methodsFor: 'accessing' stamp: 'fredaebi 3/12/2012 07:54'!
entity
	^ entity.! !

!DCD6Suspect methodsFor: 'accessing' stamp: 'fredaebi 3/12/2012 07:54'!
entity: anEntity
	entity := anEntity.! !

!DCD6Suspect methodsFor: 'initialization' stamp: 'fredaebi 3/12/2012 07:53'!
initialize
	super initialize.! !

!DCD6Suspect methodsFor: 'accessing' stamp: 'fredaebi 3/12/2012 07:53'!
numberOfLinesOfCode 
	^ numberOfLinesOfCode.! !

!DCD6Suspect methodsFor: 'accessing' stamp: 'fredaebi 3/12/2012 07:53'!
numberOfLinesOfCode: aNumber
	numberOfLinesOfCode := aNumber.! !

!DCD6Suspect methodsFor: 'accessing' stamp: 'fredaebi 3/12/2012 07:54'!
type
	^ type.! !

!DCD6Suspect methodsFor: 'accessing' stamp: 'fredaebi 3/12/2012 07:54'!
type: aType
	type := aType.! !

!DCD6Suspect methodsFor: 'accessing' stamp: 'fredaebi 3/12/2012 07:57'!
valid
	^ valid.! !

!DCD6Suspect methodsFor: 'accessing' stamp: 'fredaebi 3/12/2012 07:57'!
valid: aBoolean
	valid := aBoolean.! !

Object subclass: #DCD6Version
	instanceVariableNames: 'number date time selected'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DCD6'!

!DCD6Version methodsFor: 'accessing' stamp: 'fredaebi 3/23/2012 09:17'!
date
	^ date.! !

!DCD6Version methodsFor: 'accessing' stamp: 'fredaebi 3/23/2012 09:18'!
date: aValue
	date := aValue.! !

!DCD6Version methodsFor: 'initialization' stamp: 'fredaebi 3/23/2012 09:17'!
initialize
	super initialize.! !

!DCD6Version methodsFor: 'accessing' stamp: 'fredaebi 3/23/2012 09:17'!
number
	^ number.! !

!DCD6Version methodsFor: 'accessing' stamp: 'fredaebi 3/23/2012 09:18'!
number: aValue
	number := aValue.! !

!DCD6Version methodsFor: 'accessing' stamp: 'fredaebi 3/23/2012 09:18'!
selected
	^ selected.! !

!DCD6Version methodsFor: 'accessing' stamp: 'fredaebi 3/23/2012 09:18'!
selected: aValue
	selected := aValue.! !

!DCD6Version methodsFor: 'accessing' stamp: 'fredaebi 3/23/2012 09:17'!
time
	^ time.! !

!DCD6Version methodsFor: 'accessing' stamp: 'fredaebi 3/23/2012 09:18'!
time: aValue
	time := aValue.! !
